%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

%define
%PLTversion = '14Sep23';
%end_define

%
%
%
%
%

function [Ret1,Ret2] = plt(varargin);

%
global Hhcpy;

Ret1 = 0;
Narg = nargin;
mver = version;  Mver = mver(1:4);
if Mver(4) == '.'
   Mver(4) = Mver(3);  Mver(3) = '0';
end;
Mver = s2d(Mver(1:4));
MverE = (Mver<8.04);
%

if ~Narg
  wplt = getappdata(0,'wplt'); lw = length(wplt);
  options = [];
  TraceIDlength = 7;
%
  fig = figure('menu','none','numberT','off','back','off','name','PLT select','color','black','Invert','on');
  if lw v = fieldnames(wplt);
  else  eval('evalin(''base'',''pltdef'','''')');
        v = plt('select','base','who');
  end;
  w = {}; m=0;
  for k=1:length(v)
    if lw a = getfield(wplt,v{k});
    else  a = plt('select','base',v{k});
    end;
    if length(v{k})>5 & strfind(v{k},'pltopt') options = [options a]; end;
    if strcmp(v{k},'TraceIDlen') TraceIDlength = a;  end;
    if isnumeric(a) & length(a)>3
           m=m+1; w(m)=v(k);  if lw setappdata(gcf,sprintf('a%d',m),a); end;
    elseif isstruct(a) & numel(a)==1
      f = fieldnames(a);
      for fn=1:length(f)
        g = getfield(a,f{fn});
        if isnumeric(g) & length(g)>3
           m=m+1; w{m} = [v{k} '.' f{fn}];  if lw setappdata(gcf,sprintf('a%d',m),g); end;
        end;
      end;
    end;
  end;
  if lw rmappdata(0,'wplt'); end;
  if m<2 disp('Not enough vectors to plot'); close(fig); return; end;
  spix = get(0,'screenp');
  fontsz = (196-spix)/10;
  spix = spix/80 - .2;
  vspace = round(20 * spix);
  hspace = round(200 * spix);
  set(0,'unit','pix');  ssz = get(0,'screensize');
  nc = fix((ssz(4)-110)/(vspace+.2));
  m3 = m+3;  nc = ceil(m3/nc);
  nr = ceil(m3/nc);
  wid = nc*hspace+20; hei = nr*vspace+55;
  set(fig,'pos',figpos([inf inf wid hei]));
  axes('xlim',[0 nc],'ylim',[0 nr+1]-.5,'pos',[.02/nc 0 1 1],...
       'color','black','xcol','black','ycol','black');
  hc = [hei-25 40 21];  hb = hc + [0 20 0];  p = {[25 hc] [ 80 hb] [155 hc]};
  uic('Str',{'Plot','CloseAll','Help'},'Pos',p,'fontsize',fontsz,...
      'Callb',{'plt select plot;' 'plt close;' 'plt help;'});
  text(.05,nr-2.2,{'Right click on desired x vectors';
                   'Left click on desired y vectors';
                   'Double click for right hand axis'},...
                   'fonta','ita','fontsi',9,'color',[0 1 .5]);
  txt = zeros(m,1); sz1=txt; sz2=txt; len=txt; nvec=txt; sxy=txt; yright=txt;
  y=nr-3; x=0;
  for k=1:m
    y = y-1;  if y<0 y=nr-1; x=x+1;  end;
    if lw sz = getappdata(gcf,sprintf('a%d',k));  else sz = plt('select','base',w{k}); end;
    sz = size(sz);
    sz1(k)  = sz(1);
    sz2(k)  = sz(2);
    len(k)  = max(sz);
    nvec(k) = min(sz);
    txt(k) = text(x,y,' ');
    set(txt(k),'buttond',['plt(''select'',' int2str(k) ');']);
  end;
  set(fig,'userdata',[txt sz1 sz2 len nvec sxy yright]);
  setappdata(fig,'w',w);
  setappdata(fig,'opt',options);
  setappdata(fig,'IDlen',TraceIDlength);
  plt select text;
  return;
end;

if Narg>2 & isfield(varargin{2},'Type') & strcmp(varargin{2}.Type,'TimerFcn')
   varargin(1:2)=[]; Narg=Narg-2;
end;

y1 = varargin{1}; 
if length(y1)==1 & ishandle(y1)
  y2 = varargin{2};
  if isempty(y2) | ~isnumeric(y2)
    varargin(1:2)=[]; Narg=Narg-2;
    y1 = varargin{1};
  end;
end;
if ~ischar(y1)  y1='none'; end;
y1 = lower(y1); y1s = sum(y1);
if y1s==632 & y1(1)~='r' y1s=0; end;
switch y1s
case 640
  v2 = varargin{2};
  if isnumeric(v2) | v2(1) ~= 'b'
      w = getappdata(gcf,'w');  e = get(gcf,'userdata');
      len = e(:,4); sxy = e(:,6); nov = length(len);
      xk = []; for k=1:nov if sxy(k)<0 xk = [xk k]; end; end;
  end;
  switch sum(v2)
    case 411, Ret1 = eval(['evalin(''base'',''' varargin{3} ''');']);
    case 453,
      lnxk = length(xk);
      for k=1:nov
        s = w{k};  if length(s)>20 s=s(1:20); end;
        s = strrep(s,'_','\_');
        s = [s '  (' int2str(e(k,2)) ',' int2str(e(k,3)) ')'];
        if sxy(k) s = [s ' \leftarrow ']; s2 = int2str(abs(sxy(k)));  end;
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
        c = [1 1 1];
        if lnxk
          if lnxk==1 s2 = ''; end;
          if ~sxy(k)
            if ~length(find(len(xk)==len(k))) c = .5*c; end;
          elseif sxy(k)<0                 c = [.9 .3 .3]; s = [s 'x' s2];
          else
            if e(k,7)               c = [ 1 .6 .2]; s = [s 'y' s2 'R'];
                      else                c = [ 1  1  0]; s = [s 'y' s2];
                      end;
          end;
        else if e(k,5) ~= 1 c = .5*c; end;
        end;
        if c(3)==.5 | c(3)==1 bold = 'norm'; else bold = 'bold';  end;
        set(e(k,1),'color',c,'fontw',bold,'str',s);
      end;
    case 447
      if ~max(sxy) return; end;
      options       = getappdata(gcf,'opt');
      TraceIDlength = getappdata(gcf,'IDlen');
      opt = [];
      for k=1:length(options)
        t = options{k};
        if   isnumeric(t) v = num2str(t);
             if length(t)>1
               q = v;  v = '[';
               for j=1:size(q,1) v = [v q(j,:) ';']; end;
               v = [v ']'];
             end;
        else v = ['''' t ''''];
        end;
        opt = [opt v ','];
      end;
      if length(xk)==1 x = w{find(sxy<0)}; else x = 'X axis'; end;
      right = [];
      ny = 0;
      nvL = 0; nvR = 0;
      func = ['plt(''LabelX'',''' x ''','];
      id = '''TraceID'',[''';
      lw = length(getappdata(gcf,'a1'));
      for k=1:nov
        if sxy(k)>0
          nvec = e(k,5);
          xi = find(sxy==-sxy(k));
          x = w{xi};  y = w{k};
          s2 = strrep(y,'_','\_');
          ss = strrep(y,'_','');
          nn = TraceIDlength - (nvec>1);  s = [];
          if length(ss) > nn
            sp = strfind(ss,'.');
            if length(sp)
              nn1 = min(sp-1,floor((nn-1)/2));
              nn2 = min(nn-nn1-1,length(ss)-sp);
              nn1 = nn - nn2 - 1;
              ss = ss([1:nn1-1 sp-1:sp+nn2-1 end]);
%
            else
              ss = [ss(1:nn-1) ss(end)];
            end;
          end;
          while length(ss)<nn ss = [ss ' ']; end;
          st = ss;
          for v = 1:nvec
            if nvec>1 ss=[st '0'+mod(v,10)]; end;
            s = [s ss ''';'''];
          end;
          if e(k,7) right = [right ny+(1:nvec)]; s2R=s2; nvR=nvR+1; else s2L=s2; nvL=nvL+1; end;
          ny = ny + nvec;
          if lw  y = 'getappdata(gcf,''a%d'')';  x = sprintf(y,xi);  y = sprintf(y,k);  end;
          func = [func x ',' y ','];
          id = [id s];
        end;
      end;
      if nvL==1 func = [func '''LabelY'','''  s2L ''',']; end;
      if nvR==1 func = [func '''LabelYr'',''' s2R ''',']; end;
      if nvR>0  func = [func '''Right'',' prin('[{%d }]',right) ',']; end;
      if ny>1 func = [func id(1:end-2) '],']; end;
      func = [func opt '''+'',2);'];
      if lw eval(func); else evalin('base',func); end;
    otherwise,
      click = sum(get(gcf,'SelectionT'));  sk = sxy(v2);
      if click==321 | ~length(xk)
        if sk>=0
             if e(v2,5)==1 e(v2,6) = min(sxy)-1; end;
        else e(v2,6) = 0;
             e(find(sxy==-sk),6)=0;
        end;
      elseif sk>=0
        if click==434 & sk sk = 0; end;
        xki = sort(-sxy(xk(find(len(xk)==len(v2)))));
        if length(xki)
          if sk m = find(xki==sk)+1;
                if m>length(xki) sk=0; e(v2,7)=0; else sk=xki(m);  end;
          else  sk = xki(1);
          end;
          e(v2,6) = sk;
          if click==434 & sk e(v2,7)=1; end;
        end;
      end;
      set(gcf,'userdata',e);
      plt('select','text');
  end;
%
  
case 756
  x = varargin{2};
  if Narg==2
%
%
%
%
%
    m=0;  nv=x;
    if ~x Ret1=''; Ret2=1; return; end;
    while nv>900  m=m+1;  nv=.001*nv; end;
    while nv<.9   m=m-1;  nv=1000*nv; end;
    if (m==1 & x<10000) | (m==-1 & x>=.1 ) m=0; nv=x; end;
    Ret2 = x/nv;
    Ret2 = 10^round(log10(Ret2));
    if     m>10  Ret1 = Pftoa('%4w',Ret2);
    elseif m<-10 Ret1 = Pftoa('%5w',Ret2);
    else qs = ['Quecto'; 'Ronto '; 'Yocto '; 'Zepto '; 'Atto  '; 'Femto '; 'Pico  '; 'Nano  '; 'Micro '; 'Milli '; '      ';
               'Kilo  '; 'Mega  '; 'Giga  '; 'Tera  '; 'Peta  '; 'Exa   '; 'Zetta '; 'Yotta '; 'Ronna '; 'Quetta'];
         Ret1 = deblank(qs(m+11,:));
    end;
    if length(Ret1) Ret1 = [Ret1 '-']; end;
  else
    v3 = varargin{3};  ax = x;
    xm = getappdata(ax,'xmult');  if isempty(xm) xm = 1; end;
    ym = getappdata(ax,'ymult');  if isempty(ym) ym = 1; end;
    h = getappdata(ax,'Lhandles'); nh = length(h);
    a = get(h,'par'); if nh>1 a = [a{:}]; end;  left = (a==ax);
    right = find(~left);
    if length(right) axr = get(h(right(1)),'par'); else axr = []; end; 
    switch lower(v3(1));
      case 'g',  Ret1 = xm;  Ret2 = ym;
      case 'b',  Ret1 = plt('metricp',ax,'x');
                 Ret2 = plt('metricp',ax,'y');
      case 'x',  xli = get(ax,'xlim') * xm;
                 [pfix XM] = plt('metricp',max(abs((xli))));
                 m = xm/XM;  Ret1 = XM;
                 if abs(m-1) < .001 return; end;
                 for k=1:nh set(h(k),'x',m*get(h(k),'x')); end;
                 lbl = get(ax,'xlab');  s = get(lbl,'str');
                 if xm~=1 s = s(strfind(s,'-')+1:end); end;
                 set(lbl,'str',[pfix s]);
                 xli = xli/XM;
                 set(ax,'xlim',xli);  setappdata(ax,'xmult',XM);
                 if length(axr)
                   set(axr,'xlim',xli); setappdata(axr,'xmult',XM);
                 end;
      case 'y',  yli = get(ax,'ylim') * ym;
                 [pfix YM] = plt('metricp',max(abs((yli))));
                 m = ym/YM;  Ret1 = YM;
                 if abs(m-1) < .001 return; end;
                 for k=1:nh
                   if left(k) set(h(k),'y',m*get(h(k),'y')); end;
                 end;
                 lbl = get(ax,'ylab');  s = get(lbl,'str');
                 if ym~=1 s = s(strfind(s,'-')+1:end); end;
                 set(lbl,'str',[pfix s]);
                 set(ax,'ylim',yli/YM);  setappdata(ax,'ymult',YM);
      case '-',  switch lower(v3(end));
                 case 'x'
                   if xm==1 return; end;
                   for k=1:nh set(h(k),'x',get(h(k),'x')*xm); end;
                   lbl = get(ax,'xlab');  s = get(lbl,'str');
                   set(lbl,'str',s(strfind(s,'-')+1:end));
                   xli = get(ax,'xlim')*xm;
                   set(ax,'xlim',xli);  setappdata(ax,'xmult',1);
                   if length(axr)
                     set(axr,'xlim',xli); setappdata(axr,'xmult',1);
                   end;
                 case 'y'
                   if ym==1 return; end;
                   for k=1:nh
                     if left(k) set(h(k),'y',get(h(k),'y')*ym); end;
                   end;
                   lbl = get(ax,'ylab');  s = get(lbl,'str');
                   set(lbl,'str',s(strfind(s,'-')+1:end));
                   set(ax,'ylim',get(ax,'ylim')*ym);  setappdata(ax,'ymult',1);
                 otherwise,  plt('metricp',ax,'-x'); plt('metricp',ax,'-y');
                 end;
      end;
  end;
%

case 759
%
%
  c = datevec(varargin{2});
  if isempty(c) | isnan(c(1)) Ret1 = []; return; end;
  frac = sprintf('%4.3f',mod(c(6),1));
  c(6) = floor(c(6));
  if strcmp(frac,'1.000')
    if c(6)==59 frac = '0.999'; else c(6) = c(6)+1;  end;
  end;
%
%
  if Mver < 7
       if Narg<3 fmt=0; else fmt=varargin{3}; end;
       Ret1 = [datestr(datenum(c),fmt) frac(2:end)];
       if strcmp(Ret1(7:9),'-20') Ret1(8:9) = []; end;
  else
       if Narg<3 fmt = 'dd-mmm-yy HH:MM:SS';
%
       else      fmt = varargin{3};
       end;
       Ret1 = datestr(datenum(c),fmt);
       p = strfind(Ret1,':');
       if length(p) ~= 2 return; end;
       p = p(2);
       Ret1 = [Ret1(1:p+2) frac(2:end) Ret1(p+3:end)];
  end;
%

case 425
  if Narg==1        f = '';
  elseif sum(get(gcf,'SelectionT'))==321 f = get(gcbo,'tag');
  else              f = get(gcbo,'userdata');
  end;
  tp = '';
  if exist('tp')
    if length(f)
      if isempty(strfind(f,'.')) eval(f); return; end;
      dd = strfind(f,'::');
      if length(dd) tp=f(dd:end); f=f(1:dd-1); end;
      if isempty(strfind(f,filesep))
        f = feval('which',f);
      end;
      if ~exist(f) f = ''; end;
    end;
    if isempty(f)
      fc = feval('which','plt.chm'); nc=length(fc);
      fh = feval('which','plt.htm'); nh=length(fh);
      if (nc+nh)==0
         na = get(gcf,'name');
         r = strfind(na,' ('); if length(r) na = na(1:r(1)-1); end;
         fc = feval('which',[na '.chm']);  nc=length(fc);
         fh = feval('which',[na '.htm']);  nh=length(fh);
         if ~nh fh = feval('which',[na '.pdf']);  nh=length(fh); end;
         if (nc+nh)==0 disp(['No plt or ' na ' help files were found']); return; end;
      end;
      if ispc if nc f=fc; else f=fh; end;
      else    if nh f=fh; else f=fc; end;
      end;
    end;
    if ispc & strcmpi(f(end-2:end),'chm')
         dos(['hh ' f tp ' &']);
    else feval('web',strrep(['file:///' f tp],'plt.htm::',''),'-browser');
    end;
  else
    if isempty(f) f = 'plt.chm'; end;
    dos(['hh ' fullfile(fileparts(GetExe),f) ' &']);
  end;
%

case 878
  if Narg>1 a = varargin{2}; else a = 'off'; end;
  s = getappdata(gca,'helptext'); n = length(s);
  if ~n & Narg<3
    e = findobj(gcf,'type','axes','tag','click')';
    for k=e  s=getappdata(k,'helptext'); n=length(s);
             if n axes(k); break; end;
    end;
    if ~n return; end;
  end;
  ht = findobj(gca,'userdata',355/113);
  if a(1)=='t' Ret1 = ht; return; end;
  if a(1)=='g' Ret1 = s; return; end;
  if a(2)=='f' | length(ht) delete(ht); return; end;
  if Narg>2
    if n plt('helptext'); end;
    s = varargin{3};  n = length(s);
    setappdata(gca,'helptext',s);
    if a(1)=='s' return; end;
  end;
  if ~n return; end;
  if ~iscell(s) s = {s}; n=1; end;
  a = find(~cellfun('isreal',s));
  if length(a) a = [a n+1];
  else         s = [s {.03+.96i}];  a = n+[1 2];
  end;
  p = 1;  btn = get(gca,'buttond');  props = {};
  for k=1:2:length(a)
    p1 = a(k);  p2 = a(k+1);  pos = s{p1};  props = [props s(p1+1:p2-1)];
    h = text(real(pos),imag(pos),s(p:p1-1),'unit','nor','fontsize',12,...
             'color',[1 .6 0],'vert','top','userdata',355/113,'buttond',btn);
    for m=1:2:length(props) r=props{m}; v=props{m+1}; if strcmpi(r,'color') v=ctrip(v); end; set(h,r,v); end;
    if p2<length(s) & imag(s{p2})>0 props = {}; end;
    p = p2+1;
  end;
%

case 515
  h = varargin{2};
  if ischar(h)
    img = findobj(gcf,'tag',['img' h]);
    cmd = varargin{3};
    switch lower(cmd(1))
    case 'i',
      [xy k] = cur(0,'get');
      xcur = real(xy);  ycur = imag(xy);
      z = get(img,'Cdata');  y = get(img,'y');
      [v m] = min(abs(y-ycur));
      cur(0,'updateN',k,xcur,y(m));
      if k > size(z,2) | m > size(z,1) za = NaN; else za = z(m,k); end;
      zeo = getappdata(gca,'zeo');  undo = zeo(2);  zeo = zeo(1);
      if length(cmd)<5
        plt('edit',zeo,'val',za);   ob = cur(0,'obj');
        if Mver >= 7
          if isnan(za) za = -inf; end;  cl = get(gca,'clim');
          if MverE mp = gcf; else mp = gca; end;  mp = get(mp,'colormap'); np = length(mp);
          c = 1 + fix(np*(za-cl(1))/diff(cl));  c = min(max(1,c),np);  gry = [.2; .6; .2];
          c = mp(c,:);  cg = c*gry;
          a = [1 1 0; 0 0 1; 0 1 0; 1 0 0];  ag = a*gry;
          [mx i] = max(abs(ag-cg) + sum(abs(a - repmat(c,4,1))')');
          set(ob(15),'color',a(i,:));
        end;
        set(ob([4 6]),'vis','off');
      elseif ~isnan(za)
        if cmd(5)=='E'
           u = {m 1 m k 1 k z(m,k)};
           z(m,k) = plt('edit',zeo);  set(img,'Cdata',z);
           setappdata(gcf,'IcurFill',[m k]);
        else
           if sum(get(gcf,'SelectionT'))~=321  a = getappdata(gcbo,'btnd');  feval(a{:}); return; end;
           k2 = getappdata(gcf,'IcurFill');   if isempty(k2) return; end;
           m2 = k2(1);  k2 = k2(2);  mi = (m2>m)*2-1;  ki = (k2>k)*2-1;
           u = {m mi m2 k ki k2 z(m:mi:m2,k:ki:k2)};
           z(m:mi:m2,k:ki:k2) = z(m2,k2);
           set(img,'Cdata',z);
        end;
        uu = getappdata(img,'undo');
        if isempty(uu) | ~isequal(u(1:6),uu(1:6))
          setappdata(img,'undo',[u uu]);
        end;
        set(undo,'vis','on');
        plt('image',h,'Icur');
      end;
    case 'u'
      u = getappdata(img,'undo');
      if isempty(u) return; end;
      z = get(img,'Cdata');  u7 = u{7};
      z(u{1}:u{2}:u{3},u{4}:u{5}:u{6}) = u7;  u(1:7) = [];
      if length(u7)>1 & length(u)>6 & length(u{7})==1
        z(u{1}:u{2}:u{3},u{4}:u{5}:u{6}) = u{7};  u(1:7) = [];
      end;
      set(img,'Cdata',z);
      setappdata(img,'undo',u);
      if isempty(u) set(gcbo,'vis','of'); end;
      plt('image',h,'Icur');
    case 's'
      zstat = get(img,'userdata');
      r = findobj(gcf,'tag',['edge' h]);
      if length(r) r = plt('slider',r); else r=0; end;
      if ~r clim = zstat(3:4);  if ~diff(clim) clim = clim + [-1 1]; end;
      else
        r = r*zstat(2); if isnan(r) | r==0 r = .01; end;
        m = findobj(gcf,'tag',['mid' h]);
        if length(m) m = plt('slider',m); else m=0; end;
        m = m*zstat(2) + zstat(1);  if isnan(m) m=0; end;
        clim = m + [-r r];
      end;
      set(get(img,'par'),'Clim',clim);
    case 'c'
      if MverE c = findobj(gcf,'tag','cbar');
      else     c = findobj(gcf,'buttond',['plt image ' h ' cbar;']);
      end;
      if isempty(c) return; end;
      n = '';
      if nargin>3 u = varargin{4};
                  if iscell(u) n = u{1};  s = u{2};
                               w = getappdata(0,'cmaps');  w{length(w)+1} = u;
                               setappdata(0,'cmaps',w);    u = length(w)+9;
                  elseif ischar(u) u = s2d(u);
                  end; 
      else        u = get(c(1),'userdata') + 2*(sum(get(gcf,'SelectionT'))~=321) - 1;
                  if ~exist('n') u = mod(u,5);
                  else w = getappdata(0,'cmaps');
                       u = mod(u,10+length(w));
                  end;
      end;
      set(c,'userdata',u);
      if isempty(n)
        switch(u)
          case 0,  s = 'jet';
          case 1,  n = 'Rainbow';
                   t = 0.04761904739229; t2 = t/2;  
                   a = ones(1,22);  b = ones(1,21);  d = t2:t:1;
                   s = [[0*b;d;b] [d;b;1-t2:-t:0] [a;1:-t:0; 0*a]]';
          case 2,  n = 'Sometric';
                   s = [0 4 0; 5 7 3; 10 9 0; 8 6 10; 5 2 1; 10 10 9];
                   s = round(interp1(linspace(1,64,6),s*100,1:64))/1000;
          case 3,  n = 'Seismic';
                   t = ones(1,22);  b = 0*t; w = (0:21)/22;  s = [b w 1]; f = fliplr(w);
                   b = [f b];  s = [s t f; s b; w t 1 b]';  s = s((1:64)+12,:);
          case 4,  s = 'gray';
          case 5,  s = 'colorcube';
          case 6,  s = 'lines';
          case 7,  s = 'hot';
          case 8,  s = 'cool';
          case 9,  s = 'winter';
          otherwise, w = getappdata(0,'cmaps');  n = w{u-9};  s = n{2};  n = n{1};
        end;
        if isempty(n) n=s; end;
      end;
      m = colormap(get(img,'par'),s);  if ~MverE m = colormap(get(c,'par'),s); end;
      for k=1:length(c)
        set(c,'Cdata',transpose(63:-1:0)*length(m)/64);
        t = findobj(get(c(k),'par'),'type','text');
        set(t,'str',n);
      end;
    case 'v'
      ax = get(img,'par');
      if sum(get(gcf,'SelectionT'))~=321 ilim = getappdata(ax,'ilim');  ilim = ilim(1:4);
      else         xl = get(ax,'xlim');  yl = get(ax,'ylim');
                   zo = findobj(gcf,'str','Zout')';
                   cid = get(gca,'userdata');
                   for k = zo  b = get(k,'buttond');
                               if b{3}==cid setappdata(ax,'ilim',[xl yl]); return; end;
                   end;
                   ilim = .15*[1 -1]; ilim = [xl+diff(xl)*ilim  yl+diff(yl)*ilim];
      end;
      cur(get(ax,'userdata'),'xylim',ilim);
    end;
    return;
  end;
  x = varargin{3};  vn = length(varargin);
  if ischar(x)
    c=x; zstat=[]; x=varargin{4}; xx=[];
    imgS = get(h,'tag'); imgS=imgS(4:end);
    gn = 5;
    while length(c)
      c = lower(c);
      switch c
        case 'x',             set(h,'x',x);                  xx = x;
        case 'y',             set(h,'y',x);
        case 'z',             set(h,'Cdata',x);              zstat = x(:);
        case 'xy',            y = varargin{gn};  gn=gn+1;
                              set(h,'x',x,'y',y);            xx = x;
        case 'xz',            y = varargin{gn};  gn=gn+1;
                              set(h,'x',x,'Cdata',y);        zstat = y(:);  xx = x;
        case 'yz',            y = varargin{gn};  gn=gn+1;
                              set(h,'y',x,'Cdata',y);        zstat = y(:);
        case 'xyz',           y = varargin{gn};  z = varargin{gn+1};  gn=gn+2;
                              set(h,'x',x,'y',y,'Cdata',z);  zstat = z(:);  xx = x;
        case 'cbar',          plt('image',imgS,'cbar',x);
        case {'edge' 'mid'},  plt('slider',findobj(gcf,'tag',[c imgS]),'set',x);
        case {'xlim' 'ylim'}, set(get(h,'par'),c,x);
        case 'direct',        if x v='direct'; else v='scaled'; end; set(h,'CdataMapping',v);
      end;
      if vn>=gn c=varargin{gn}; x=varargin{gn+1}; gn=gn+2; else c=[]; end;
    end;
    if length(xx) set(findobj(gcf,'tag','imgLine'),'x',xx,'y',xx*NaN); end;
    if length(zstat) zstat(isnan(zstat)) = [];
                     zstat = [mean(zstat) std(zstat) min(zstat) max(zstat)];
                     set(h,'userdata',zstat);
                     plt('image',imgS,'slider');
    end;
  else
    y = varargin{4};  z = varargin{5};  w = 1;  scaled = 1;
    if nargin>5 opt = varargin{6}; n = length(opt); else n = 0; end;
    pc = [];  pm = [];  pe = [];  pg = [];  pv = [];  cmap = 0;
    ax = getappdata(gcf,'axis');   ax = ax(h);  set(ax,'box','off');
    ah = get(ax,'pos'); al = ah(1);  ab = ah(2);  aw = ah(3);  ah = ah(4);
    l = getappdata(ax,'Lhandles');  fh = get(gcf,'pos');  fw = fh(3);  fh = fh(4);
    if length(l)<1 disp('Error, image axis must contain at least one trace'); return; end;
    while n >= w
      cas = opt{w};  w=w+1;
      if n >= w & ~ischar(opt{w})  v=opt{w};  w=w+1;  else v=[]; end;
      switch lower(cas(1))
        case 'c',  if length(v) pc = v;
                   else pc = [al-59/fw  ab+.5273*ah  18/fw  .3669*ah];
                   end;
                   cmap = cas(end)-'0';  cmap = cmap * (cmap>=0 & cmap<=9); 
        case 'm',  if length(v) pm = v;
                   else pm = [al-94/fw  ab+.18*ah  17/fw  .293*ah];
                   end;
        case 'e',  if length(v) pe = v;
                   else pe = [al-59/fw  ab+.18*ah  17/fw  .293*ah]; end;
        case 'g',  if length(v) pg = v;
                   else pg = [al+aw-94/fw  5.6/fh  48/fw  20/fh];
                   end;
                   gON = cas(1)=='G';
        case 'v',  if length(v) pv = v;
                   else pv = [al+aw-41/fw  8/fh  48/fw  15/fh];
                   end;
        case 'd',  scaled = 0;
      end;
    end;
    zstat = z(:);  zstat(isnan(zstat)) = [];
    zstat = [mean(zstat) std(zstat) min(zstat) max(zstat)];
    set(l(1),'x',x,'y',x*NaN,'tag','imgLine');
    b = axes;
    img = image(x,y,z);
    if scaled set(img,'CdataMapping','scaled'); end;
    if MverE ht='on'; else ht='off'; end;
    imgN = getappdata(gcf,'imgN');  if isempty(imgN) imgN = 1; else imgN = imgN+1; end;
    setappdata(gcf,'imgN',imgN);
    imgS = sprintf('%d',imgN);  imgP = ['plt image ' imgS ' '];  axb = get(ax,'buttond');
    set(img,'par',ax,'buttond',axb,'userdata',zstat,'tag',['img' imgS]);
    delete(b);
    if length(getappdata(gcf,'xli')) xli = get(ax,'xlim');
    else                             xli = [min(x) max(x)];  dx=max(diff(xli),1)/50;  xli = xli + [-dx dx];  set(ax,'xlim',xli);
    end;
    if length(getappdata(gcf,'yli')) yli = get(ax,'ylim');
    else                             yli = [min(y) max(y)];  dy=max(diff(yli),1)/50;  yli = yli + [-dy dy];  set(ax,'ylim',yli);
    end;
    ilim = [xli yli];
    setappdata(ax,'ilim',ilim);
    grd = plt('grid',ax);
    uistack(grd,'top');
    if MverE set(grd,'erase','xor');
    else     set(grd,'linestyle',':','color',[.4 .4 .4]);
             uistack(findobj(ax,'color',[1 1 .51]),'top');
    end;
    if length(pv) uistack(uicontrol('sty','text','str','view all','unit','nor','pos',pv,...
                             'ena','inact','buttond',[imgP 'view;']),'bottom');
    end;
    if length(pg)
      set(grd,'tag','       ','vis',char('of'+[0 8*gON]));
%
      uic('sty','checkbox','userdata',grd,...
        'str','grid','val',gON,'unit','nor','pos',pg,...
        'callback','set(get(gcbo,"user"),"vis",char("of"+[0 8*get(gcbo,"value")]));');
    end;
    setappdata(ax,'offline',1);
    axes(ax); zc = [.3 1 .3];
    zeo = plt('edit',[.36,-.06],NaN,[imgP 'IcurEdit;'],'fontsize',12,'color',zc,...
              'format','%-6V','Label',{'Z :    ',[],'color',zc});
    zl = plt('edit',zeo,'get','label');
    set(zl,'unit','pix');  px = get(zl,'pos');  set(zl,'unit','nor');
    undo = text(px(1)-55,px(2)+2,'\leftarrow','color',zc,'unit','pix','vis','of','buttond',[imgP 'undo;']);
    set(undo,'unit','nor');
    setappdata(ax,'zeo',[zeo undo]);
    setappdata(zl,'btnd',get(zl,'buttond'));
    set(zl,'buttond',[imgP 'IcurFill;']);
    k = round(length(x)/2);
    ob = cur(-h,'obj');  s = [imgP 'Icur; ' get(ob(6),'userdata')];
    cur(-h,'moveCB',s);
    cur(-h,'updateN',k,x(k),mean(get(ax,'ylim')));
    ns = length(s);
    if length(pc)
      c = axes('pos',pc);  z = transpose(1:64);
      image(z,'buttond',[imgP 'cbar;'],'tag','cbar');
      text(.475,1.023,'','unit','nor','rot',90,'color','white');
      set(c,'vis','of');  axes(ax);
    end;
    imgPS = [imgP 'slider;'];
    if length(pm) hm = plt('slider',pm,[0 -1 1], 'mid', imgPS,1,'4'); set(hm,'tag',['mid' imgS]); end;
    if length(pe) he = plt('slider',pe,[1 0 2.5],'edge',imgPS,1,'3'); set(he,'tag',['edge' imgS]); end;
    plt('image',imgS,'cbar',cmap);
    plt('image',imgS,'slider');
    ERAS = 'eras';  em = 'norm';
    if ~MverE ERAS = 'pi';  em = 'v';  elseif Mver<7 em = 'xor'; end;
    mk = findobj(ax,'marker','+','vis','on');
    set(mk,'MarkerSize',16,'Marker','*',ERAS,em,'buttond',axb);
    uistack(mk,'top');
    eval(s);
    Ret1 = img;
  end;
%

case 329
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

  pos = varargin{2};
  if iscell(pos)
    Ret1 = [];  n = length(pos);
    for k = 1:n
      v = {'box'};
      for m = 2:Narg   a = varargin{m};  if iscell(a) & length(a)==n  a = a{k}; end;  v = [v {a}];  end;
      Ret1 = [Ret1; plt(v{:})];
    end;
    return;
  end;

  if length(findobj(gcf,'type','axes')) ax = gca; else ax = []; end;
  b = varargin(3:end);  a = [];  c = [1 1 1]/12;  xy = c;
  if length(b)
    a = b{1};
    if strcmp(a,'none') b(1) = [];  c = a; xy = 6*xy;
    elseif isnumeric(a) b(1) = [];  c = ctrip(a);  xy = c;
    end;
  end;
  if length(a) & length(b) & isnumeric(b{1})  xy = ctrip(b{1});  b(1) = [];  end;
  if max(pos)<5 u = 'norm'; else u = 'pix'; end;
  Ret1 = axes('units',u,'pos',pos,'box','on','xtick',[],'ytick',[],'color',c,...
              'xcolor',xy,'ycolor',xy,'linewidth',3,'tag','frame');
  for k = 1:2:length(b)-1  set(Ret1,b{k},b{k+1});
                           if strcmpi(b{k},'xlim'); ax = []; end;
  end;
  uistack(Ret1,'bottom');
  if length(ax) axes(ax); end;
%

case 335
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

%
%
%
%
%
%
%

  b = varargin;  a1 = b{2};  n = length(a1);
%
  if n>1 & ishandle(a1(1)) a1 = num2cell(a1);  b{2} = a1; end;

  if iscell(a1)  
    Ret1 = [];
    for k = 1:n
      v = {'pop'};
      for m = 2:Narg   a = b{m};  if iscell(a) & length(a)==n  a = a{k}; end;  v = [v {a}];  end;
      Ret1 = [Ret1; plt(v{:})];
    end;
    return;
  end;
  
  k = 2;  nvar = length(b);
  if nvar==2 b = [b {'get'}];  nvar = nvar+1; end;
  e = b{end};  if ischar(e)
                 if length(find(sum(lower(e)) == [443 410 320 434]));
                    b = [b {''}]; nvar = nvar+1;
                 end;
               end;
  if isnumeric(a1) & ~ischar(b{3})
     a1 = 'pos'; a4 = [b(1) {a1} b(2) {'choices'}];
     if mod(nvar,2) b = [a4 b(3:nvar)];
     else           b = [a4 b(3) {'callbk'} b(4:nvar)];
     end;
  end;
  if ischar(a1)
       if length(findobj(gcf,'type','axes')) g = gca; else g = []; end;
       bk = [0 .3 .4];
       a = axes('vis','of','XtickLabel',' ','YtickLabel',' ','TickLen',[0 0]','color',bk,'xcol',bk,'ycol',bk);
%
       pd = {a     ''       1      ''      99    [.1 1 .9]     1      []   'none'   -1   0 };
       Ret1 = text(0,0,'','units','data','userdata',pd,'interp','none','color',[1 1 .4]);
%
       setappdata(gcf,'pop',[getappdata(gcf,'pop') Ret1]);
       setappdata(Ret1,'ty','pop');  setappdata(a,'ty','pop');
       set(Ret1,'buttond',{@plt 'pop' Ret1 'open'});
       set(a,'userdata',Ret1);
       if length(g) axes(g); end;
  else Ret1 = a1;  k = k+1;   pd = get(Ret1,'userdata');   a = pd{1};
  end;
  nvar = length(b);  ofs = [];  cb = 0;
  while k <= nvar
    argn  = lower(b{k}); argv = b{k+1}; k=k+2;
    switch sum(argn)
    case {338,885},
                    switch length(argv)
                      case 1, fp=get(a,'pos'); argv=[fp(1:3) argv];
                      case 2, fp=get(a,'pos'); argv=[fp(1:2) argv];
                    end;
                    if argv(1)<0 argv(1)=-argv(1); pd{5}=0; end;
                    if argv(2)<0 argv(2)=-argv(2); pd{11}=1; edg(Ret1,pd{6}); end;
                    if max(argv)>1 u='pixels'; else u='normal'; end;
                    set(a,'units',u,'pos',argv);
    case 734,  if isnumeric(argv)
                      if sum(mod(argv,1)) fm = '{%5w!row}'; else fm = '{%d!row}'; end;
                      argv = prin(fm,argv);
                    end;
                    pd{2} = argv;
    case 434,
                    if pd{7}<1 return; end;
                    mv = get(Ret1,'buttond');
                    if iscell(mv) mv = mv{2}(1); else mv = mv(5); end;
                    mv = (mv=='m');
                    if xor(sum(get(gcf,'SelectionT'))==649,pd{11}) & ~(sum(get(gcf,'SelectionT'))==434) | mv
                      uh = findobj(pd{8},'vis','on');
                      setappdata(Ret1,'Uhide',uh);
                      set([Ret1; uh],'vis','of');  ch = pd{2};  n = length(ch);
                      set(a,'vis','on');  axes(a);
                      s = {@plt 'pop' Ret1 'index'};  w = get(gcf,'pos');
                      q = get(a,'pos');  q = q(3);  if q<1 q = q*w(3); end;
                      p = 5/q;  q = (q-10)/q;
                      for m=1:n 
                        ht = text(p,n+.5-m,ch{m},'units','data');
                        set(ht,'interp',pd{9},'color',pd{6},'buttond',[s {-m}]);
                        if m==pd{3} set(ht,'fontw','bol'); end;
                      end;
                      cr = get(a,'color');  cc = [1 1 1] * (max(cr)>.5);
                      ht = text(q,0.5,'X','units','data','fontw','bol');
                      set(ht,'interp','tex','color',cc,'buttond',[s {0}]);
                      z = zeros(1,n-1);  x = [z;z+1;z];  z = [z;z;z+NaN];   y = 1:n-1;  y = [y;y;y];
                      line('z',z(:),'y',y(:),'x',x(:),'color',cr-.2+.4*(cr<.5),'userdata',w);
                    else
                      g = gcf;  setappdata(g,'bdown',1);
                      set(g,'WindowButtonUpFcn','setappdata(gcf,''bdown'',0);');
                      n = length(pd{2});  v = pd{3};
                      [rpt p] = getREPEAT;
                      while ishandle(g) & getappdata(g,'bdown')
                        if v==n v=1; else v=v+1; end;
                        plt('pop',Ret1,'index',-v);
                        if rpt < 0 break; end;
                        q=p; while q>0 & ishandle(g) & getappdata(g,'bdown') pause(.01); q=q-.01; end;
                        p = rpt;
                      end;
                    end;
                    return;
    case 410,     if isempty(argv) argv = 0; end;
                    z = find(argv==0);
                    if length(z) grd = findobj(gcf,'user','grid')';
                                 argv(z) = [];  argv = [argv grd];
                    end;
                    pd{8} = argv;
    case 647,   pd{5} = argv;
    case 759,  pd{6} = argv;
    case 748,  set(a,'color',argv,'xcol',argv,'ycol',argv);
    case 658,   pd{9} = argv;  set(Ret1,'interp',argv);
    case 443,     pd{11} = 1;  if isempty(argv) argv = 'none'; elseif length(argv)==1 argv = pd{6}; end;
                    edg(Ret1,argv);
    case 536,    w = abs(argv);  if w pd{3} = w; end;
                    if isVIS(a)
                      if ~w p = get(a,'pos');  sp = 1 + MverE + (Mver<7);
                            for j = 49:-sp:1 set(a,'pos',p .* [1 1 1 j/50]); pause(.001); end;
                            set(a,'pos',p);
                      end;
                      set(a,'vis','of');  ch = get(a,'child'); li = findobj(ch,'type','line');
                      dp = sum(abs(get(li,'userdata') - get(gcf,'pos')));
                      if dp>0 & dp<20
                        pd{11} = 1 - pd{11};
                        disp('swap toggled');
                      end; 
                      ch(find(ch==Ret1)) = [];  ch(find(ch==pd{10})) = [];
                      li = getappdata(Ret1,'li');  if ishandle(li) ch(find(ch==li)) = []; end;
                      delete(ch);
                      uh = getappdata(Ret1,'Uhide');
                      set([Ret1; uh],'vis','on');
                      ch = gcf;
                      if Mver < 7.05
                        set(ch,'Share','off');
                        set(ch,'Share','on');
                      end;
                    end;
                    cb = (argv<0);
    case 617,   pd{4} = argv;  set(Ret1,'userdata',pd);
    case 320,      switch sum(argv)
                      case 663,  Ret1 = get(Ret1,'str');
                      case 437,      Ret1 = pd{1};
                      case 734,   Ret1 = pd{2};
                      case {536,0}, Ret1 = pd{3};
                      case 617,    Ret1 = pd{4};
                      case 647,    Ret1 = pd{5};
                      case 759,   Ret1 = pd{6};
                      case 615,    Ret1 = pd{7};
                      case 410,      Ret1 = pd{8};
                      case 658,    Ret1 = pd{9};
                      case 512,     Ret1 = pd{10};
                      case 443,      Ret1 = pd{11};
                      otherwise,       Ret1 = pd;
                    end;
                    return;
    case 615,   pd{7} = argv;  set(Ret1,'userdata',pd);  vs = char('on' - [0 8]*(argv<0));  set(Ret1,'vis',vs);
                                      if ishandle(pd{10}) set(pd{10},'vis',vs); end;
    case {512 633},
                    if ischar(argv) argv = {argv ''}; end;
                    s = argv{1};
                    q = argv{2};
                    if isempty(q)
                      if sum(argn)==512 q = -5;
                      else  q = (16 + pd{11}*(6 - 3*MverE)) * 1i;
%
%
                      end;
                    end;
                    q = [real(q) imag(q)];
                    if ~q(2) & q(1)<0 hz = 'right'; else hz = 'left'; end;
                    t = text(0,0,s,'units','data','horiz',hz,'color',[.6 .6 .8],'par',a,'userdata',q);
                    pd{10} = t;
                    j=3;  while length(argv)>j set(t,argv{j},argv{j+1}); j=j+2; end;
    otherwise,      r = [argn '   '];  r = r(1:4);
                    if strcmp(r,'fore') | strcmp(r,'back') argv = ctrip(argv); end;
                    set(Ret1,argn,argv);
    end;
  end;
  c = pd{2};  n = length(c);  f = pd{5};  i = pd{3};  s = c{i};
  if length(f)<2 f=[.08 f]; end;
  if f(2)==99 f(2)=n; end;
  set(a,'ylim',[0 n]);
  set(Ret1,'pos',f,'str',s,'userdata',pd);
  edg(Ret1);
  if strcmp(c{end},'Modify\uparrow\downarrow')
    set(Ret1,'vis','of');  hpop = getappdata(gcf,'epopup');
    if length(hpop) set(getappdata(hpop,'EdHide'),'vis','on'); end;
  end;
  p = get(a,'pos');
  t = pd{10};
  if ishandle(t)
    e = p(3:4);
    if p(1)<1  r = get(gcf,'pos'); e = e .* r(3:4); end;
    q = get(t,'userdata')./e;  q(2)=q(2)*n;
    set(t,'pos',f+q);
  end;
  p(4) = p(4)/n;
  setappdata(Ret1,'ppos',p - [([0 .3]-f) .4 .4] .* p([3 4 3 4]));
  if cb evalRep(pd{4},{'@STR',s,'@IDX',int2str(i)}); end;
%

case 422
if MverE  ERAS = 'eras';  ERAXOR = 'xor';  ERANOR = 'norm';
else      ERAS = 'pi';    ERAXOR = 'v';    ERANOR = 'v';
end;
if y1(1) == 'g'
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
  if Narg==1 ax = gca;
  else       ax = varargin{2};  if ax==0 ax = gca; end;
  end;
  if Narg<3 Action='update'; else  Action = varargin{3};  end;
  Action = sum(Action);
  if Action == 436
    if Narg<4 grdclr = [.13 .13 .13]; else grdclr = varargin{4}; end;
    if Narg<5 erMode = ERAXOR;  else erMode = varargin{5}; end;
    if Narg<6 sty = '-';        else sty    = varargin{6}; end;
    f = findobj(ax,'type','line');
    if length(f) f=get(f(1),'buttond'); end;
    Ret1 = line('color',grdclr,'tag','SkipCur','buttond',f,'linest',sty,'user','grid',ERAS,erMode);
    set(Ret1,'par',ax);
    setappdata(Ret1,'clr',grdclr);
    Action = 221;
    if Narg >= 7 set(Ret1,varargin{7},varargin{8}); end;
    if Narg >= 9 set(Ret1,varargin{9},varargin{10}); end;
%
    set(ax,'child',flipud(get(ax,'child')));
  else  Ret1 = findobj(ax,'user','grid');
        if length(Ret1) ~= 1 return; end;
        z = get(Ret1,'z');   e = length(z);
        if e e = z(1) | e>=2; end;
  end;

  switch Action
  case 643, if e Action=221; end;
                fixMark;
  case 642, if e Action=315; else Action=221; end;
  end;

  switch Action
  case 221,  z = 1;  l = [get(ax,'xlim') get(ax,'ylim')];
             s = get(ax,'Xscale');  t = 1;
             if s(2)=='o' &  l(2)/l(1)<getappdata(gcf,'logTR')
               t = get(ax,'XtickLabel'); if iscell(t) t = [t{:}]; else t = t(:)'; end;
               t = length(strfind(t,'.'));
             end;
             if t  xt = [l(1) get(ax,'XTICK') l(2)]; n=length(xt);
                   if xt(2) <= xt(1)   xt = xt(2:n); n=n-1; end;
                   if xt(n) <= xt(n-1) n=n-1;  xt = xt(1:n); end;
             else  xt = logTicks(l(1:2));  n = length(xt);
             end;
             s = get(ax,'Yscale');  t = 1;
             if s(2)=='o' & l(4)/l(3)<getappdata(gcf,'logTR')
               t = get(ax,'YtickLabel'); if iscell(t) t = [t{:}]; else t = t(:)'; end;
               t = length(strfind(t,'.'));
             end;
             if t  yt = [l(3) get(ax,'YTICK') l(4)]; m=length(yt);
                   if yt(2) <= yt(1)   yt = yt(2:m); m=m-1; end;
                   if yt(m) <= yt(m-1) m=m-1;  yt = yt(1:m); end;
             else  yt = logTicks(l(3:4));  m = length(yt);
             end;
             t = m + n - 4;
             if t s = ones(3,1);  y = [1 m m];  x = [1 n n];  n=n-1;  m=m-1;
                  z = [0;0;NaN] * ones(1,t);           z=z(:);
                  y = [s*yt(2:m)  yt(y)'*ones(1,n-1)]; y=y(:);
                  x = [xt(x)'*ones(1,m-1) s*xt(2:n)];  x=x(:);
             else x = 0;  y = 0;  z = 0;
             end;
             tlen = [ 0   0  ];
  case 315, tlen = [.01 .025]; x=0; y=0; z=0;
  otherwise, return;
  end;
  set(Ret1,'z',z,'y',y,'x',x);  set(ax,'TickLen',tlen);
%
else
%

%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

%

%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

  b = varargin;  a1 = b{2};  n = length(a1);
  if n>1 & ishandle(a1(1))
    ty = get(a1(1),'type');
    if ~strcmp(ty,'root') & ~strcmp(ty,'figure')  a1 = num2cell(a1);  b{2} = a1;  end;
  end;

  if iscell(a1)  
    Ret1 = [];
    for k = 1:n
      v = {'edit'};
      for m = 2:Narg   a = b{m};  if iscell(a) & length(a)==n  a = a{k}; end;  v = [v {a}];  end;
      Ret1 = [Ret1; plt(v{:})];
    end;
    return;
  end;

  k = 2;   a0 = b(1);  nvar = Narg;
  if nvar==2 b = [b {'get'}];  nvar = nvar+1; end;
  e = b{end};
  if ischar(e) & sum(lower(e)) == 320  b = [b {''}]; nvar = nvar+1;  end;
  if isnumeric(a1) & isnumeric(b{3})
     if     max(a1)<4      a0 = {'edit' 'units' 'norm'};
     elseif length(a1)==2  a0 = {'edit' 'units' 'pix'};
     end;
     a1 = 'pos'; a0123 = [a0 {a1} b(2) {'val'}];
     if mod(nvar,2) b = [a0123 b(3:nvar)];
     else           b = [a0123 b(3) {'callbk'} b(4:nvar)];
     end;
     nvar = length(b);
  end;
  if ischar(a1)
       ui = 0;
       for z = 2:2:nvar  d = b{z};
                         if lower(d(1))=='p' ui = length(b{z+1}); break; end;
       end;
       if ~ui disp('You must specify a position for the edit pseudo object'); return; end;
       ui = (ui==4);
%

%
       pd = { 1  -1e99 1e99     ''      1    1     1  '%6w'  -1   ''    ''  };

       c = get(gcf,'color')/2;  f = [1 1 .4];  if sum(c)>1.5 f = 1-f; end;
       if Mver < 7 fsz = 8; else fsz=9; end;
       if ui ut='uic'; Ret1 = uicontrol('style','text','fontsi',fsz,'ena','inact','foregr',f,'backgr',c);
       else  ut='txt'; Ret1 = text(0,0,'1','horiz','cent','color',f);
       end;
       setappdata(gcf,ut,[getappdata(gcf,ut) Ret1]);
       setappdata(Ret1,'ty','edi');
       set(Ret1,'userdata',pd,'buttond',{@plt 'edit' Ret1 'click' 0});
  else Ret1 = a1;  k = k+1;  pd = get(Ret1,'userdata');
  end;
  ui = get(Ret1,'type');  ui = (ui(1) == 'u');
  if ui cp = 'foregr'; gc = gcf;   nun = 'pix';
  else  cp = 'color';    gc = gca;   nun = 'data';
  end;
  while k <= nvar
    argn  = lower(b{k}); sargn = sum(argn); argv = b{k+1}; k=k+2;
    switch sargn
    case 518,
      if argv
        c = get(gcf,'CurrentChar');
        if ~length(c) c=666;  end;
        if argv==2 c=27; end;
        t = get(Ret1,'str');   u = get(Ret1,cp);
        p = strfind(t,'_');  n = length(t);
        done = 0;            eeval = 0;
        switch abs(c)
        case 666,
        case 8,    if p>1 t(p-1)=[]; end;
        case 127,  if p==n t='_'; else t(p+1)=[];  end;
        case 28,   if p>1 t(p)=t(p-1); t(p-1)='_'; end;
        case 29,   if p<n t(p)=t(p+1); t(p+1)='_'; end;
        case 31,   t = '_';
        case 27,   done = 1;  t = pd{10};
        case 13,   done = 1;
                   t(p) = [];
                   if pd{7}
                     tt=t;  t = 'error';
                     try, s = eval(tt);
                        if pd{7}==-1 | pd{7}==length(s)
                          if length(s)==1
                            if isreal(s)
                                 s = max(min(s,pd{3}),pd{2});
                                 t = ['  ' Pftoa(pd{8},s) '  '];
                            else pd{6} = imag(s);
                                 t = pd{10};
                            end;
                          else  t = ['[' num2str(s) ']'];
                          end;
                          eeval = 1;  if isreal(s)  pd{1} = s;  end;
                        end;
                     end;
                   else pd{1}=0; eeval=1;
                   end;
%
        otherwise, t = strrep(t,'_',[c '_']);
        end;
        set(Ret1,'str',t);
        if done
          set(Ret1,'userdata',pd,cp,u([3 1 2]))
          if ~ui set(Ret1,ERAS,ERANOR,'interp',pd{11}); end;
          if Mver<7 ky = gcf; edg(Ret1); else ky = [gcf; findobj(gcf,'type','uicontrol')]; end;
          set(ky,'keypress',' ');
          if eeval setappdata(gcf,'OBJ',Ret1);  evalRep(pd{4},{'@VAL' t '@OBJ' 'plt("misc",3)'}); end;
        end;
      else
        kp = get(gcf,'keypress');
        if iscell(kp) & length(kp)==5 & kp{4}(1)=='c'
           kp{5}=2;  plt(kp{2:end}); return;
        end;
        if pd{5}<1 return; end;
        c = sum(get(gcf,'SelectionT'));
        if c ~= 321
          v = pd{1}; w = pd{6};
          if pd{7}==1 & isfinite(w) & w
            cp = get(gc,'currentp'); cp = cp(1,1);
            rp = get(Ret1,'pos');  un = get(Ret1,'unit');
            if un(1) ~= nun(1)
              set(Ret1,'units',nun);
              rp2 = rp;  rp = get(Ret1,'pos');
              set(Ret1,'units',un,'pos',rp2);
            end;
            cp = cp > rp(1) + ui*rp(3)/2;
            cp = 2*cp - 1;
            [rpt p] = getREPEAT(0);
            setappdata(gcf,'bdown',1);
            set(gcf,'WindowButtonUpFcn','setappdata(gcf,''bdown'',0);');
            m = 0;
            while getappdata(gcf,'bdown')
              if w<0 vf = (1 - w/100)^cp;
                     if v v = v*vf;
                     else v = vf-1;
                     end;
              else   v = v + w*cp;
              end;
              if     v>pd{3} if m break; else v=pd{2}; end;
              elseif v<pd{2} if m break; else v=pd{3}; end;
              end;
              m = 1;  pd{1} = v;  s = ['  ' Pftoa(pd{8},v) '  '];
              set(Ret1,'str',s,'userdata',pd);
              setappdata(gcf,'OBJ',Ret1); evalRep(pd{4},{'@VAL' s '@OBJ' 'plt("misc",3)'});
              if rpt < 0 break; end;
              q=p; while q>0 & getappdata(gcf,'bdown') pause(.01); q=q-.01; end;
              p = rpt;
            end;
            return;
          elseif isfinite(w) c=321;
          else               setappdata(gcf,'OBJ',Ret1);
                             evalRep(pd{4},{'@VAL' ['  ' Pftoa(pd{8},v) '  '] '@OBJ' 'plt("misc",3)'});
          end;
        end;
        if c==321
          t = get(Ret1,'str');
          if ~strcmp(t,'error') pd{10} = t; end;
          t = deblank(t);  while(t(1)==' ') t(1)=[]; end;
          oldc = get(Ret1,cp);
          if ~ui pd{11} = get(Ret1,'interp'); set(Ret1,'interp','none',ERAS,ERAXOR); end;
          set(Ret1,'str',[t '_'],cp,oldc([2 3 1]),'userdata',pd);
%
%
%
%
%
          if Mver<7 ky = gcf; else ky = [gcf; findobj(gcf,'type','uicontrol')]; end;
          set(ky,'keypress',{@plt 'edit' Ret1 'click' 1});
        end;
      end;
    case 320,    switch sum(lower(argv))
                  case {0,541}, Ret1 = pd{1};
                  case 650,    Ret1 = [pd{2:3}];
                  case 617,    Ret1 = pd{4};
                  case 615,    Ret1 = pd{5};
                  case 428,      Ret1 = pd{6};
                  case 642,    Ret1 = pd{7};
                  case 649,    Ret1 = pd{8};
                  case 512,     Ret1 = pd{9};
                  otherwise,       Ret1 = pd(1:9);
                  end;
    case {541,323,650},
                  if     length(argv)==3  pd(2:3) = {argv(2) argv(3)};
                  elseif length(argv)==2  pd(2:3) = {argv(1) argv(2)}; set(Ret1,'userdata',pd);  return;
                  end;
                  pd{1}  = argv(1);  s = ['  ' Pftoa(pd{8},argv(1)) '  '];
                  set(Ret1,'str',s,'userdata',pd);
                  if sargn==541 setappdata(gcf,'OBJ',Ret1); evalRep(pd{4},{'@VAL',s,'@OBJ','plt("misc",3)'}); end;
    case 617, pd{4} = argv;  set(Ret1,'userdata',pd);
    case 428,   pd{6}   = argv;  set(Ret1,'userdata',pd);
    case 642, pd{7}    = argv;  set(Ret1,'userdata',pd);
    case 615, pd{5}    = argv;  set(Ret1,'userdata',pd);  vs = char('on' - [0 8]*(argv<0));  set(Ret1,'vis',vs);
                                       if ishandle(pd{9}) set(pd{9},'vis',vs); end;
    case 649, if     isnumeric(argv) argv = sprintf('%%%dw',argv);
                  elseif length(argv)<2  argv = ['%' argv 'w']; end;
                  pd{8} = argv;
                  set(Ret1,'str',['  ' Pftoa(argv,pd{1}) '  '],'userdata',pd);
    case 638, if ~ui if length(argv)<3 argv = get(Ret1,'color'); end; edg(Ret1,argv);  edg(Ret1); end;
    case 512,  if ishandle(argv)
                       m = argv;  argv = getappdata(m,'argv');
                  else m = -1;
                  end;
                  if ischar(argv) if isempty(argv) return; end; argv = {argv ''}; end;
                  p = get(Ret1,'pos');  u = get(Ret1,'units');  hz = 'right';
                  s = argv{1};  q = argv{2};
                  if ui
                    r = length(s);   tl = strfind(s,'~');
                    if length(tl)  tl = tl(end);  s(tl) = [];  r = tl-1; end;
                    r = round(22 + 6.5*r);
                    if u(1)=='n' sz=get(gcf,'pos'); r=r/sz(3); end;
                    switch length(q)
                    case 0, q = [p(1)-r p(2) r p(4)];
                    case 1, q = [p(1)-q p(2) q p(4)];
                    case 2, w = q(1);  if ~w w = r; end;
                            xo = real(q(2));  yo = imag(q(2));
                            q = [p(1)+xo-w p(2)+yo w p(4)];
                            if ~xo  q(1) = p(1)+(p(3)-w)/2;  hz = 'cent';  end;
                    case 4, hz='cent';
                    end;
                    if ishandle(m) set(m,'pos',q); return; end;
                    a = uicontrol('sty','text','str',s,'units',u,'pos',q,'foregr',[.6 .6 .8],'backgr',get(Ret1,'backgr'),...
                             'horiz',hz,'fontsi',fsz,'buttond',get(Ret1,'buttond'),'ena','inact','userdata',Ret1,'tag','E');
                  else
                    p = p(1:2);  tl = strfind(s,'~');  rr = 0;
                    if length(tl)  rr = length(s)-tl; s(tl) = []; end;
                    switch length(q)
                    case 0, r = pd{8};  t = length(get(Ret1,'str')) - 4;
                            r = max([t length(Pftoa(r,pd{2})) length(Pftoa(r,pd{3}))]);
                            r = 5 + 4*r - 2*rr;
                            if u(1)=='n' sz=get(gcf,'pos'); r=r/sz(3); end;
                            q = p - [r 0];
                    case 1, xo=real(q); yo=imag(q); q=p+[xo yo];
                            if ~xo hz='cent'; end;
                    case {2,3}, hz='cent';
                    end;
                    if ishandle(m) set(m,'pos',q); return; end;
                    a = text(q(1),q(2),s,'units',u,'horiz',hz,'color',[.6 .6 .8],...
                             'buttond',get(Ret1,'buttond'),'userdata',q(1:2)-p);
                  end;
                  j=3;  while length(argv)>j set(a,argv{j},argv{j+1}); j=j+2; end;
                  pd{9} = a;  set(Ret1,'userdata',pd);
                  setappdata(a,'argv',argv(1:2));
    otherwise,    a = [argn '   '];  a = a(1:4);
                  if strcmp(a,'fore') | strcmp(a,'back') argv = ctrip(argv); end;
                  set(Ret1,argn,argv);
                  a = pd{9};
                  if ishandle(a) & argn(1)=='p' plt('edit',Ret1,'label',a); end;
    end;
  end;
end;

case 643

b = varargin;  a1 = b{2};  n = length(a1);
%
  if n>1 & ishandle(a1(1)) a1 = num2cell(a1);  b{2} = a1; end;

  if iscell(a1)  
    Ret1 = [];
    for k = 1:n
      v = {'slider'};
      for m = 2:Narg   a = b{m};  if iscell(a) & length(a)==n  a = a{k}; end;  v = [v {a}];  end;
      Ret1 = [Ret1; plt(v{:})];
    end;
    return;
  end;

  if ~ishandle(a1)
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
     if Narg>2  In2 = b{3}; else In2 = 100;   end;
     if Narg>3  In3 = b{4}; else In3 = '';    end;
     if Narg>4  In4 = b{5}; else In4 = '';    end;
     In5 = 1;  In6 = '%2w %6w %3w';  In7 = [.75 .75 .75; 0 1 1];
     for k=6:8
       if Narg<k break; end;
       v = b{k};
       if isnumeric(v)
          if length(v)<3 In5 = v; else In7 = v; end;
       else In6 = v;
       end;
     end;
     if isempty(In2)                      In2 = 100; end;
     if length(In2)==1                    In2 = [0 In2]; end;
     if length(In2)==2 | length(In2)==4   In2 = [mean(In2(1:2)) In2]; end;
     if length(In2)==3                    In2 = [In2 -1e99 1e99]; end;
     if length(In7(:,1))<3                In7 = [In7; 0 0 0; 0 0 0]; end; 
     if ischar(In6) & length(In6(:,1))==1
        d = find(In6 == ' ');
        if length(d)<2 In6 = ['%2w ' In6 ' %3w'];  d = find(In6 == ' '); end;
        In6 = {In6(1:d(1)-1) In6(d(1)+1:d(2)-1) In6(d(2)+1:end)};
     end;
     if iscell(In6)
       for k=1:3  d=In6{k}; if length(d)<2 In6{k} = ['%' d 'w']; end; end;
       In6 = char(In6);
     end;
     hs = zeros(1,8);
%
     hs(2)  = uicontrol('sty','text','str',In3,'horiz','cent');  if isempty(In3) set(hs(2),'vis','off'); end;
     Ret1       = hs(2);        cb = {@plt 'slider' Ret1};
     hs(4) = uicontrol('sty','text','str','a','userdata',In6,'horiz','left');
     hs(5) = uicontrol('sty','text','str','a','userdata',In4,'horiz','right');
     hs(3)  = uicontrol('sty','slid','userdata',In2(1),'callback',[cb {'CBslide'}]);
     hs(6)  = uicontrol('sty','edit','backg',In7(2,:),'foreg',In7(4,:),'userdata',In2(4:5),'horiz','cent','callback',[cb {'CBedit'}]);
     set(hs(2:5),'backg',In7(1,:),'foreg',In7(3,:));
     In5 = [In5 10];  hs([7 8]) = In5(1:2);
     if hs(7)==5 & In2(4)<0 In2(4) = 1e-99; end;
     set(hs(2),'userdata',hs);
     plt('slider',Ret1,'minmax',In2(2:5),In2(1));
     if length(a1)==4
       q = a1(4)*1000;
          if round(1e6 * (q - fix(q))) == 123  len2=3; a1 = a1(1:3) + [0 .1 0]; end;
       end;
     plt('slider',Ret1,'pos',a1);
     if length(a1)<4
       setappdata(gcf,'sli',[getappdata(gcf,'sli') hs(2:6)]);
     end;
     return;
  end;

%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%
%

  hs   = get(a1,'userdata');
  fmat = get(hs(4),'userdata');

  if nargin>2 Action = b{3}; else Action = 'get'; end;
  if isnumeric(Action) plt('slider',a1,'value',Action); return; end;
  if Narg>3  In1 = b{4};  else In1 = ''; end;
  if Narg>4  In2 = b{5};  else In2 = []; end;
  if Narg>5  In3 = b{6};  else In3 = []; end;

  switch sum(lower(Action))
  case 726
     oldval = get(hs(3),'userdata');    newval = get(hs(3),'val');  sval = [];
     smax   = get(hs(3),'max');   smin   = get(hs(3),'min');
     dv = newval-oldval;  sdv = sign(dv);
     switch hs(7)
     case 4,
        v = hs(8)*round(newval/hs(8));
        if v==oldval v = v + hs(8)*sdv; end;
        newval = v;
     case 2,
        v = round(newval);
        if v==oldval v = v + sdv; end;
        newval = v;
     case 5, sval = newval; newval = exp(sval);
     case 3,
        if newval >= get(hs(3),'userdata')-eps  newval=2^nextpow2(newval);
        else                                  newval=2^nextpow2(newval/2);
        end;
     case 6,
        pdv = abs(dv)/(smax-smin);
        if     pdv < .02   newval = oldval + hs(8)*sdv;
        elseif pdv < .11   newval = oldval + hs(8)*sdv*10;
        end;
        newval = hs(8)*round(newval/hs(8));
     end;
     if isempty(sval)
       if newval<smin newval = smin; elseif newval>smax newval = smax; end;
       sval = newval;
     end;
     set(hs(6),'str',Pftoa(fmat(2,:),newval));
     set(hs(3),'val',sval,'userdata',newval);
     evalRep(get(hs(5),'userdata'),{'@VAL',sprintf('%g',newval)});

  case 619
     newval = s2d(get(hs(6),'str'));    sval = [];
     minmax = get(hs(6),'userdata');
     if isempty(newval)
         set(hs(6),'str',Pftoa(fmat(2,:),get(hs(3),'val')));
     else
        switch hs(7)
        case 2,  newval = round(newval);
        case 3,  newval = 2 ^ nextpow2(newval/1.414);
        case 4, newval=hs(8)*round(newval/hs(8));
        case 5,     newval = min(max(newval,minmax(1)),minmax(2));
                       sval = log(newval);
        end;
        newval = min(max(newval,minmax(1)),minmax(2));
        Ret1 = newval;
        set(hs(6),'str',Pftoa(fmat(2,:),newval));
        if isempty(sval) sval = newval; end;
        sval = max(min(get(hs(3),'max'),sval),get(hs(3),'min'));
        if hs(7)==5 newval = exp(sval); end;
        set(hs(3),'val',sval,'userdata',newval);
        evalRep(get(hs(5),'userdata'),{'@VAL',sprintf('%g',newval)});
     end;

  case 320
     switch sum(In1)
     case 750,         Ret1 = isVIS(get(hs(2)));
     case 308,             Ret1 = strcmp(get(hs(2),'ena'),'on');
     case 315,             Ret1 = hs(2:6);
     case {338 885}, Ret1 = get(hs(2),'pos');  Ret1 = Ret1(1:3);
     otherwise              Ret1 = get(hs(3),'userdata');
     end;
  case 332
     if isnumeric(In1) set(hs(6),'str',num2str(In1));
                       Ret1 = plt('slider',a1,'CBedit');
     elseif Narg>3  b(3)=[];  plt(b{:});
     end;
  case 541
     set(hs(6),'str',num2str(In1));
     Ret1 = plt('slider',a1,'CBedit');
  case 323
     set(hs(6),'str',num2str(In1));
     sv = get(hs(5),'userdata');  set(hs(5),'userdata','');
     Ret1 = plt('slider',a1,'CBedit');
     set(hs(5),'userdata',sv);
  case 559,  set(hs(2:6),'vis','on')
                if isempty(get(hs(2),'str')) set(hs(2),'vis','of'); end;
  case 653, set(hs(2:6),'vis','of');
  case 623, set(hs([3 6]),'ena','of');
  case 529,  set(hs([3 6]),'ena','on');
  case {338 885},
     ob = hs(2:6);
     if ~iscell(In1)
       len2 = length(In1);
       switch len2
         case 8,     In1 = {In1(1:4) In1(5:8)};
         case {4,5}, wid = 8+6*length(get(ob(1),'str')); dx = 2;  dy = 4;
                     if max(In1)<3 w=get(gcf,'pos'); wid=wid/w(3); dx=dx/w(3); dy=dy/w(4); end;
                     if len2==5 wid = In1(5); end;
                     if In1(4)>In1(3) pl = [In1(1)-(wid-In1(3))/2 In1(2)+In1(4)+dy wid 4*dy];
                        else          pl = [In1(1)-wid-2*dx In1(2) wid In1(4)];
                     end;
                     In1 = {In1(1:4) pl};
       end;
     end;
     if iscell(In1)
       if length(In1)==2
         ps = In1{1}; pl = In1{2};  ps=ps(:); pl=pl(:);
         if ps(4)>ps(3) pe = [pl(1) [0 2 0 1]*ps-[0 1 0 1]*pl-dx pl(3) pl(4)+dx];
         else           pe = [[2 0 1 0]*ps-[1 0 1 0]*pl pl(2:4)'];
         end;
         In1 = {pl'; ps'; []; []; pe};
       end;  
       ie = find(cellfun('isempty',In1))';
       if max(In1{2})>3
             for k=ie In1{k}=[-99 9 9 9]; end;  set(ob,'unit','pix',{'pos'},In1);
       else  for k=ie In1{k}=[2 2 .1 .1]; end;  set(ob,'unit','nor',{'pos'},In1);
       end;
     else
       a = (get(0,'screenp')-96)/10;
       p = get(gcf,'pos');  w = p(3);  h = p(4);
       if length(In1<3) In1 = [In1 120]; end;
       lmax = 7 + 7*fix(s2d(fmat(3,2:(length(deblank(fmat(3,:)))-1))));
       lmin = 7 + 7*fix(s2d(fmat(1,2:(length(deblank(fmat(1,:)))-1))));
       if isnan(lmax) lmax = 28; end;
       if isnan(lmin) lmin = 14; end;
       h0=a+17;  h1=16+a/2;  h2=17-a-1;  h3=a+17;  h5=h3+2;
       if In1(1)>=1
         if In1(3)<1 In1(3) = In1(3)*w; end;
         In1(3) = max(In1(3),65);
         ya = In1(2) - h0;
         set(ob,'unit','pix',{'pos'},...
                {[In1(1:3) h1];
                 [In1(1),In1(2)-33,In1(3),h2];
                 [In1(1),ya,lmin,h3];
                 [In1(3)+In1(1)-lmax,ya,lmax,h3];
                 [In1(1)+lmin,ya-1,In1(3)-(lmin+lmax),h5]});
       else
         if In1(3)>=1 In1(3) = In1(3)/w; end;
         In1(3) = max(In1(3),65/w);
         h1=h1/h; h2=h2/h; h3=h3/h; h5=h5/h; ya = In1(2)-h0/h;  lmin=lmin/w;  lmax=lmax/w;
         set(ob,'unit','nor',{'pos'},...
                {[In1(1:3) h1];
                 [In1(1),In1(2)-33/h,In1(3),h2];
                 [In1(1),ya,lmin,h3];
                 [In1(3)+In1(1)-lmax,ya,lmax,h3];
                 [In1(1)+lmin,ya-1/w,In1(3)-(lmin+lmax),h5]});
       end;
     end;
  case 421
     hs(7) = In1(1);
     if length(In1)>1 hs(8) = In1(2); end;
     set(hs(2),'userdata',hs);
     Ret1 = plt('slider',a1,'CBedit');
  case 650
     lg = hs(7)==5;
     if lg mn=1e-99; else mn=-1e+99; end;
     if length(In1)<4 In1 = [In1 mn 1e99]; end;
     set(hs(5),'str',[Pftoa(fmat(3,:),In1(2)) ' ']);
     set(hs(4),'str',[' ' Pftoa(fmat(1,:),In1(1))]);
     set(hs(6),'userdata',In1(3:4));
     if isempty(In2) v = s2d(get(hs(6),'str'));
     else            v = In2;
     end;
     v = min(max(v,In1(3)),In1(4));
     set(hs(6),'str',Pftoa(fmat(2,:),v));
     m1 = In1(1);  m2 = In1(2);
     if lg m1=log(m1); m2=log(m2); v=log(v); end;
     set(hs(3),'min',m1,'max',m2,'val',min(max(m1,v),m2));
     Ret1 = s2d(get(hs(6),'str'));
  case 512,  set(hs(2),'str',In1);
                if isempty(In1) set(hs(2),'vis','of'); end;
  otherwise
     disp(sprintf('Invalid Action in plt(''slider''), Action=%s',Action));
  end;
%

case 436
%
  Action = varargin{2};
  if Narg > 2  In1 = varargin{3};
               if Narg > 3  In2 = varargin{4}; end;
  end;
  switch sum(Action)
  case 436
     Hhcpy(12)= In1;
     if Narg ==4  renderer = In2; else renderer = '-painters';  end;
     Hhcpy(1)=figure('menu','none','numberT','off','back','off','resize','off','pos',auxLoc(350,105),'color',[0,.4,.4],'name','Hardcopy','tag',get(gcf,'tag'));
     foobar = 0;
     if exist('foobar')
%
          cpath = feval('which','plt.m');
     else cpath = GetExe;
     end;
     filen = [fileparts(cpath) filesep 'ini' filesep 'pltHcpy.mat'];
     if exist(filen) load(filen);
%
     else
%
%
%
%
       z = [0 0];  t = z+1;  w = [0 1];
       pS1=[z;w;[2 1];w;t;w;t;z;t;w;w];
       pS2 = 'temp.bmp';
     end;
     Hhcpy(3)   = uicontrol('sty','pop','str',['Win Meta|Bit Map|HPGL|LaserJet IIp|Post Script|Encaps PS|Windows'],...
                             'callback','plt hcpy ModePUcb;');
     Hhcpy(5)  = uicontrol('sty','radio','str','color','callback','plt hcpy rbg1 C;');
     Hhcpy(4)     = uicontrol('sty','radio','str','B&W','callback','plt hcpy rbg1 BW;');
     Hhcpy(6) = uicontrol('sty','radio','str','Clip Board','callback','plt hcpy rbg2 cb;');
     Hhcpy(8)    = uicontrol('sty','radio','str','Device','callback','plt hcpy rbg2 dev;');
     Hhcpy(7)   = uicontrol('sty','radio','str','File','callback','plt hcpy rbg2 file;');
     Hhcpy(11) = uicontrol('sty','text','str',pS2,'horiz','left');
     Hhcpy(10)  = uicontrol('sty','text','str', 'Path/File:','horiz','left');
     Hhcpy(9)  = uicontrol('str','Print','callback','plt hcpy print;','userdata',renderer);
     Hhcpy(2)   = uicontrol('str','Select File','callback','plt hcpy OpenPBcb;');
     cncl            = uicontrol('str','Cancel','callback','close(gcf)');
     h1 = Hhcpy([3 5 4 6 8 7]);
     h2 = Hhcpy([11 10]);
     h3 = [Hhcpy([9 2]) cncl];
     set(h1,{'val'},{pS1(3,1); pS1(5,1); pS1(4,1); pS1(6,1); pS1(8,1); pS1(7,1)});
     set([h1 h2],'backg',[.8,.8,.9],'foreg','black');
     set([h1 h2 h3],{'pos'},{[115 80 100 15]; [ 10 85 65 15]; [10 70  65 15]; [245 85 95 15];
                           [245 55  95 15]; [245 70 95 15]; [10 35 330 15]; [ 10 50 65 15];
                           [110  5  55 20]; [ 10  5 85 20]; [180 5  55 20]});
%
     for i=1+1:12-1
       if pS1(i,2)==1  set(Hhcpy(i),'ena','on'); else set(Hhcpy(i),'ena','of'); end;
     end;
     if get(Hhcpy(8),'val') set(Hhcpy(2),'str','Select Dev');
     else                       set(Hhcpy(2),'str','Select File');
     end;
%
  case 364
     switch sum(In1)
     case 67,  set(Hhcpy(5),'val',1); set(Hhcpy(4),'val',0);
     case 153, set(Hhcpy(4),'val',1);    set(Hhcpy(5),'val',0);
     end;
  case 365
     switch sum(In1)
     case 319,  set(Hhcpy(6),'val',0);  set(Hhcpy(7),'val',0);
                 set(Hhcpy(9),'ena','on'); set(Hhcpy(11),'ena','of');
                 set(Hhcpy(8),'val',1);      set(Hhcpy(2),'str','Select Dev','ena','on');
     case 197,   set(Hhcpy(6),'val',1);   set(Hhcpy(7),'val',0);
                 set(Hhcpy(9),'ena','on'); set(Hhcpy(11),'ena','of');
                 set(Hhcpy(8),'val',0);     set(Hhcpy(2),'ena','of');
     case 416, set(Hhcpy(6),'val',0);  set(Hhcpy(7),'val',1);
                 set(Hhcpy(8),'val',0);     set(Hhcpy(2),'str','Select File','ena','on');
                 fileN = get(Hhcpy(11),'str');
                 if length(fileN)<5 fileN='none'; set(Hhcpy(11),'str',fileN); end;
                 if strcmp(fileN(1:4),'none') set(Hhcpy(9),'ena','of'); end;
                 set(Hhcpy(11),'ena','on');
     end;
  case 751
     s = get(Hhcpy(3),'val');
%
     en = [1 1 0 1 1; 1 1 0 1 0; 1 1 0 1 1; 1 1 0 0 1; 0 1 0 1 1; 0 1 0 1 1; 0 0 1 1 1];
     va = [0 1 0 1 0; 0 1 0 1 0; 0 1 0 0 1; 0 1 0 0 1; 0 1 0 1 0; 0 1 0 1 0; 0 0 1 1 0];
     ext= ['wmf';     'bmp';     'hgl';     'jet';     'ps ';     'eps';     'xxx']; ext=ext(s,:);
     if s==7  set(Hhcpy(2),'str','Select Dev', 'ena','on'); set(Hhcpy(11),'ena','of');
     else     set(Hhcpy(2),'str','Select File','ena','on'); set(Hhcpy(11),'ena','on');
              fileN = get(Hhcpy(11),'str');  lf = length(fileN);
              if lf < 5 fileN='none'; set(Hhcpy(11),'str',fileN); end;
              d = strfind(fileN,'.');
              if length(d) set(Hhcpy(11),'str',[fileN(1:d(end)) ext]);
              else         set(Hhcpy(11),'str',[fileN '.' ext]);
              end;
     end;
     ena = {'off' 'on'};
     set(Hhcpy(6),'ena',ena{1+en(s,1)},'val',va(s,1));
     set(Hhcpy(7),  'ena',ena{1+en(s,2)},'val',va(s,2));
     set(Hhcpy(8),   'ena',ena{1+en(s,3)},'val',va(s,3));
     set(Hhcpy(5), 'ena',ena{1+en(s,4)},'val',va(s,4));
     set(Hhcpy(4),    'ena',ena{1+en(s,5)},'val',va(s,5));
  case 745
     if strcmp('Select File',get(Hhcpy(2),'str'))
        ext=['wmf';'bmp';'hgl';'jet';'ps ';'eps';'xxx']; ext=ext(get(Hhcpy(3),'val'),:);
        [fileN,pathN]= uiputfile(['*.',ext],'Open (new) File');
        if fileN
           fi = fileN;
           if isempty(strfind(fi,'.')) fi = [fi '.' ext]; end;
           set(Hhcpy(11),'str',[pathN fi]);  set(Hhcpy(9),'ena','on');
        end;
     elseif strcmp('Select Dev',get(Hhcpy(2),'str')) print -dsetup
     else   disp('Invalid OpenPBcb string');
     end;
  case 557
     invertStr= get(Hhcpy(12),'invert');
     set(Hhcpy(12),'invert','off');
     figure(Hhcpy(12)); drawnow;
     PrintMode = get(Hhcpy(3),'val');
     colorFlg  = get(Hhcpy(5),'val');
%
     printStr = sprintf('print -f%d',Hhcpy(12));
     renderer = get(Hhcpy(9),'userdata');
     options={[' ' renderer ' -dmeta '];' -dbitmap ';' -dhpgl ';' -dljet2p '};
     if colorFlg options = [options; {' -dpsc ';' -depsc ';' -dwinc '}];
     else        options = [options; {' -dps ' ;' -deps  ';' -dwin  '}];
     end;
     printStr=[printStr options{PrintMode,:} ' '];
     if get(Hhcpy(7),'val')==1
        PathFilen = get(Hhcpy(11),'str');  printStr=[printStr '''' PathFilen ''''];
     end;
     printStr = [printStr ' -noui'];  axh = [];  axh = findobj(Hhcpy(12),'type','axes');  nax = length(axh);
     if ~colorFlg
        figC=get(Hhcpy(12),'color');
%
        axChild = [];   axCol = zeros(nax,3);  axSpcl = zeros(nax,1);
        for i=1:nax
           x = get(axh(i),'color');
           if strcmp('none',x) axSpcl(i) = 1; else axCol(i,:)  = x; end;
           axChild = [axChild; get(axh(i),'child')];
           xCol(i,:) = get(axh(i),'xcol');  yCol(i,:) = get(axh(i),'ycol');
           tCol(i,:) = get(get(axh(i),'title'),'color');
%
           if xCol(i,:) == figC  axSpcl(i) = axSpcl(i) + 2; end;
        end;
        naxChild = length(axChild);
        for i=1:naxChild
           if sum(get(axChild(i),'type'))==528   kidCol(i,:) = get(axChild(i),'facecolor');
                                                    set(axChild(i),'facecolor',[.25 .25 .25]);
           else kidCol(i,:) = get(axChild(i),'color'); set(axChild(i),'color','black');
           end;
        end;
        set(Hhcpy(12),'color','white');
        for i= 1:nax
           if axSpcl(i)==1 | axSpcl(i)==3
           else set(axh(i),'color','white');
           end;
           if axSpcl(i)>=2 set(axh(i),'xcol','white','ycol','white' );
           else            set(axh(i),'xcol','black','ycol','black' );
           end;
        end;
        for i=1:nax
           if get(get(axh(i),'title'),'color')==figC set(get(axh(i),'title'),'color','white');
           else                                    set(get(axh(i),'title'),'color','black');
           end;
           if axSpcl(i) >=2
                set(get(axh(i),'xlab'),'color','white'); set(get(axh(i),'ylab'),'color','white');
           else set(get(axh(i),'xlab'),'color','black'); set(get(axh(i),'ylab'),'color','black');
           end;
        end;
     end;
     set(Hhcpy(1),'pointer','watch'); drawnow; pause(1);
     if PrintMode == 2
        set(Hhcpy(1),'vis','of');
        refresh
        eval(printStr);
        set(Hhcpy(1),'vis','on');
     else  drawnow;  eval(printStr);
     end;
     if ~colorFlg & (PrintMode ~=4 | PrintMode ~=7)
%
%
        set(Hhcpy(12),'color',figC);
        for i=1:nax
           if ~rem(axSpcl(i),2) set(axh(i),'color',axCol(i,:)); end;
           set(axh(i),'xcol',xCol(i,:)); set(axh(i),'ycol',yCol(i,:));
           set(get(axh(i),'title'),'color',tCol(i,:));
        end;
        for i=1:naxChild
           if sum(get(axChild(i),'type'))==528 set(axChild(i),'facecolor',kidCol(i,:));
           else                                   set(axChild(i),'color',kidCol(i,:));
           end;
        end;
        if PrintMode==2 drawnow; else drawnow discard; end;
     end;
     pS1=zeros(12-1,2);
     for i=1+1:12-1
        pS1(i,1) = get(Hhcpy(i),'val');
        if strcmp(get(Hhcpy(i),'ena'),'on') pS1(i,2)=1; end;
     end;
     pS2=get(Hhcpy(11),'str');
     foobar = 0;
     if exist('foobar')
%
          cpath = feval('which','plt.m');
     else cpath = GetExe;
     end;
     save([fileparts(cpath) filesep 'ini' filesep 'pltHcpy.mat'],'pS1','pS2');
     close(Hhcpy(1));
     set(Hhcpy(12),'invert',invertStr);
     clear Hhcpy
  otherwise disp([Action ' invalid Action in plt(hcpy)']);
  end;
%

case 428,
  in2 = varargin{2};  Ret1 = 1;
  if isnumeric(in2)
    switch in2
      case 3,  Ret1 = getappdata(gcf,'OBJ');
      case 4,  Ret1 = getappdata(gcf,'OBJ2');
      case 5,  Ret1 = getappdata(gcf,'OBJ');
               a = getappdata(gcf,'Lhandles'); Ret1 = find(a==Ret1);
      case 11, a = getap('V1');  if length(a) Ret1 = a(varargin{3}); end;
      case 12, a = getap('V2');  if length(a) Ret1 = a(varargin{3}); end;
      case 13, a = getap('V3');  if length(a) Ret1 = a(varargin{3}); end;
      case 14, a = getap('V4');  if length(a) Ret1 = a(varargin{3}); end;
      case 21, Ret1 = getap('Q1');
      case 22, Ret1 = getap('Q2');
      case 23, Ret1 = getap('Q3');
      case 24, Ret1 = getap('Q4');
    end;
    return;
  end;
  switch sum(in2)
    case 636
      if length(findobj(gcf,'tag','DeltaC','vis','on'))
         h = findobj(gcf,'str','D');  c = get(h(end),'callb');
         feval(c{1},c{2:end}); plt move res;
      else plt move;
      end;
    case 996
      if ~MverE | Mver<7 return; end;
      if length(getappdata(gcf,'LineSmooth')) u = 'off'; d = '';
      else                                    u = 'on';  d = 1;
      end;
      set(getappdata(gcf,'Lhandles'),'LineSmooth',u);
      setappdata(gcf,'LineSmooth',d);
    case 435
      cid = varargin{3};
      cur(cid,'MVcur');
      hc = cur(cid,'obj');
      c = get(hc(15),'color');
      for h = hc(3:2:5)
        s = get(h,'str');
        hh = findobj(gcf,'pos',get(h,'pos'));
        if length(hh)
          set(hh,'str',s,'backg',c);
          setappdata(hh(1),'indep',cid);
        end;
%
%
%
%
      end;
    case 548,
      fs = get(gcf,'pos');  fs = fs(3:4);
      aPt = get(gcf,'currentp');
      switch Narg
      case 2
        t = gcbo;  ax = getappdata(gcf,'axis');   m = 1;
        if strcmp(get(t,'userdata'),'grid') t=ax(1); end;
        if     any(t == findobj(gcf,'user','TraceID')) k=-1;
        elseif any(t == findobj(gcf,'tag', 'MenuBox')) k=-2;
        else
          if Mver<7 k=find(~(ax-t)); else k=find(ax==t); end;
%
          if isempty(k)
             ty = {' xy' 'uic' 'pop' 'axi'};
             id = [  0    200   100   50  ];
             for m=2:4
               tw = ty{m}; k = getappdata(gcf,tw);
               if Mver<7 k=find(~(k-t)); else k=find(k==t); end;
               k = k + id(m);
               if length(k) break; end;
             end;
          end;
        end;
        feval('assignin','base','hhh',t);
        if sum(get(gcf,'SelectionT'))==434 feval('inspect',t); feval('plotedit','off'); return; end;
        if m==3 ev=getappdata(t,'CBsv'); feval(ev{:});
                t = get(t,'par');
        elseif strcmp(get(t,'tag'),'E') t=get(t,'userdata');
        end;
        p = get(t,'pos');   r = get(t,'type');
        if r(3)=='p' | (r(3)=='c' & strcmp(get(t,'style'),'frame')) ...
                     | (r(1)=='a' & strcmp(get(t,'tag'),  'frame'))
           ch = {};
           r = p(1:2);  r = [r -r-p(3:4)] - .002;
           m = getappdata(gcf,'sli');  w = getappdata(gcf,'pop');  np = length(w);
           m = [w getappdata(gcf,'axi') getappdata(gcf,'uic') m(1:5:end)];
           for j=1:length(m)
             if j<= np q = getappdata(m(j),'ppos'); w = get(get(m(j),'par'),'pos');
             else      q = get(m(j),'pos');           w = q;
             end;
             s = q(1:2);  s = [s -s-q(3:4)];
             if all(s>r) ch = [ch {{m(j) w}}]; end;
           end;
           setappdata(t,'inside',ch);
        end;
        u = get(t,'units');  if u(1)=='n' aPt = aPt ./ fs; end;
        setappdata(gcf,'Dxy',{p aPt t k m});
        set(gcf,'WindowButtonMotionFcn','plt misc tidmv 0;',...
                'WindowButtonUpFcn',    'plt misc tidmv 0 0;');
      case 3
        s = getappdata(gcf,'Dxy'); t = s{3};
        u = get(t,'units');  u = u(1)=='n';
        if u  aPt = aPt ./ fs; end;
        r = getappdata(gcf,'snap');  r = r + 1e4*(r==0);
        if ~u  r = r ./ fs; end;
        rr = [r r];  r = [0 0 1./r];
        aPt = aPt-s{2}; s = s{1};
        if sum(get(gcf,'SelectionT'))==649
          aPt = [aPt 0 0];
          ch = getappdata(t,'inside');  cn = length(ch);
          for k = 1:cn
            h = ch{k}{1}; p = max(r,round((ch{k}{2}+aPt).*rr) ./ rr);
            ty = getappdata(h,'ty');
            switch ty(1)
              case 's', plt('slider',h,'set','pos',p);
              case 'p', plt('pop',h,'pos',p);
              otherwise set(h,'pos',p);
            end;
          end;
        else
          aPt = [0 0 aPt];
        end;
        s = s + aPt;
        s = max(r,round(s.*rr) ./ rr);
        tn = getappdata(t,'ty');
        if tn(1)=='e' plt('edit',t,'pos',s); else set(t,'pos',s); end;
      case 4
        set(gcf,'WindowButtonMotionFcn','','WindowButtonUpFcn','');
        s = getappdata(gcf,'Dxy');  t = s{3};  u = get(t,'units');
        p = get(t,'pos');  ty = getappdata(t,'ty');
        r = get(t,'type');
        if ty(1)=='p'    h = get(t,'userdata'); r = get(h,'str');
                         plt('pop',h,'index',plt('pop',h));
        elseif r(3)=='c' r = get(t,'str');
                         if iscell(r) r = r{1}; end;
        end;
        if u(1)=='n' a = strrep(prin('{ %0.3f}',p),'0.','.');
        else         a = prin('{ %4d}',round(p));
        end;
        prin(1,'%s: %3d %s;  %% %s\n',ty,s{4},a,r);
      end;
    case 579,
      switch Narg
      case 2
        t = gcbo;  ax = get(t,'par');  aPt = get(ax,'currentp');  aPt = aPt(1,1:2);
        tu = get(t,'units');
        set(t,'units','data');
        k = getappdata(gcf,'txt');  k = find(k==t);
        k = k+300;
        setappdata(gcf,'Dxy',{get(t,'pos') aPt t k tu});
        feval('assignin','base','hhh',t);
        if sum(get(gcf,'SelectionT'))==434 feval('inspect',t); return; end;
        set(gcf,'WindowButtonMotionFcn','plt misc txtmv 0;',...
                'WindowButtonUpFcn',    'plt misc txtmv 0 0;');
      case 3
        s = getappdata(gcf,'Dxy');
        t = s{3};  tp = s{1};  ax = get(t,'par');  aPt = get(ax,'currentp');

        set(t,'pos',tp(1:2)+aPt(1,1:2)-s{2});
      case 4
        set(gcf,'WindowButtonMotionFcn','','WindowButtonUpFcn','');
        s = getappdata(gcf,'Dxy'); t = s{3};
        set(t,'units',s{5}); p = get(t,'pos');
        ty = getappdata(t,'ty');     r = get(t,'str');  if iscell(r) r=r{1}; end;
        prin(1,'%s: %3d    %6V  %6V   ;  %% %s\n',ty,s{4},p(1:2),r);
        if ty(1)=='e' plt('edit',t,'pos',p); end;
      end;
    case 555,
      fs = get(gcf,'pos');  fs = fs(3:4);
      aPt = get(gcf,'currentp');
      switch Narg
      case 2
        w = getappdata(gcf,'sli');
        t = gcbo;
        k = 1 + 5*floor((find(w==t)+399)/5);
        if isempty(k) disp('slimv error'); return; end;
        t = w(k-400);
        feval('assignin','base','hhh',t);
        if sum(get(gcf,'SelectionT'))==434 feval('inspect',gcbo); return; end;
        u = get(t,'units');  if u(1)=='n' aPt = aPt ./ fs; end;
        setappdata(gcf,'Dxy',{get(t,'pos') aPt t k});
        set(gcf,'WindowButtonMotionFcn','plt misc slimv 0;',...
                'WindowButtonUpFcn',    'plt misc slimv 0 0;');
      case 3
        s = getappdata(gcf,'Dxy');  t = s{3};
        u = get(t,'units');  u = u(1)=='n';
        if u  aPt = aPt ./ fs; end;
        aPt = aPt-s{2}; s = s{1}(1:3);
        if sum(get(gcf,'SelectionT'))==649 s = s + [aPt 0];
        else                  s = max([0 0 .01],s+[0 0 aPt(1)]);
        end;
        r = getappdata(gcf,'snap');  r = r + 1e4*(r==0);
        if ~u q = get(gcf,'pos');  r = r ./ q(3:4); end;
        rr = [r r(1)];  r = [0 0 1/r(1)];
        s = max(r,round(s.*rr) ./ rr);
        plt('slider',t,'set','pos',s);
      case 4
        set(gcf,'WindowButtonMotionFcn','','WindowButtonUpFcn','');
        s = getappdata(gcf,'Dxy');  t = s{3};  u = get(t,'units');
        p = get(t,'pos');  r = get(t,'str');
        if u(1)=='n' disp(strrep(prin('sli: %3d { %0.3f}     ;  %% %s',s{4},p(1:3),r),'0.','.'));
        else         disp(prin('sli: %3d { %4d}     ;  %% %s',s{4},round(p(1:3)),r));
        end;
      end;
    case 642
      t = gco;  ax = get(t,'par');
      aPt  = get(ax,'currentp');
      if Narg==2
        switch sum(get(gcf,'SelectionT'))
        case 649
          setappdata(t,'Dxy',get(t,'pos')-aPt(1,:));
          set(gcf,'WindowButtonMotionFcn','plt misc marker 0;','WindowButtonUpFcn','set(gcf,''WindowButtonMotionFcn'','''',''WindowButtonUpFcn'','''');');
        case 321
          callp = 'plt click mark 10;';
          calle = 'plt click mark 11;';
          figure('menu','none','numberT','off','back','off','resize','off','pos',auxLoc(302,115),'color',[0,.4,.4],'name','Edit Marker','tag',get(gcf,'tag'),...
                         'closereq','plt click mark 4;');
          ed1 = uicontrol('sty','edit','pos',[8 35 130 22],'fontw','bol','callback',calle,'buttond',calle);
          pu1 = 'Delete|Color|LineStyle|LineWidth|Marker|MarkerSize|Xdata|Ydata|Zdata';
          pu1 = uicontrol('sty','pop','str',pu1,'pos',[8 65 130 20],'callback',callp,'val',5);
          uicontrol('sty','text','str', 'Marker properties:','pos',[8 94 130 17],'backg',[1 1 .6]);
          ed2 = uicontrol('sty','edit','pos',[145 35 150 22],'fontw','bol','callback',calle,'buttond',calle);
          pu2 = uicontrol('sty','pop','str','Delete|Color|FontAngle|FontName|FontSize|FontWeight|HorizontalAlign|Position|Rotation|String|VerticalAlign',...
                      'pos',[145 65 150 20],'callback',callp,'val',10);
          uicontrol('sty','text','str', 'String properties:','pos',[145 94 150 17],'backg',[1 1 .6]);
          btn = uicontrol('str','Delete all cursor annotations','pos',[73 8 160 20],'userdata',ax,'callback','plt click mark 14;')
          h = [btn ed1 pu1 ed2 pu2];  set(gcf,'userdata',h);
          set(h(2:end),'backg',[1 1 1]*.75,'foreg',[0 0 0]);
          set([ed1 ed2],'backg',[.6 1 1]);
          l = get(t,'userdata');
          setappdata(ed1,'pop',pu1); setappdata(pu1,'edt',ed1); setappdata(pu1,'obj',l);
          setappdata(ed2,'pop',pu2); setappdata(pu2,'edt',ed2); setappdata(pu2,'obj',t);
          setappdata(ed1,'m',{'str',ed1,'color',l,'Marker color'});
          setappdata(ed2,'m',{'str',ed2,'color',t,'String color'});
          if ishandle(l) l=get(l,'marker'); else l='Deleted'; end;
          if ishandle(t) t=get(t,'str');      else t='Deleted'; end;
          set(ed1,'str',l);  set(ed2,'str',t);
        end;
      else  dxy = aPt(1,:) + getappdata(t,'Dxy'); set(t,'pos',dxy(1:2));
      end;
    case 660,   aid = findobj(gcf,'user','TraceID');
                    if length(aid)
                       uistack(aid,'top');
%
%
                    end;
    case 318,
      if length(gco) f = get(gco,'par'); else f = gcf; end;
      s = get(f,'userdata');  lc = s{1}; xy = s{2};  e = s{3};  er = s{5};  cid = s{6};
      [nr nc] = size(e);  rng = get(er,'userdata');
      fp = cur(cid,'obj');  fp = get(fp(1),'par');
      switch nargin
      case 3,
        v3 = varargin{3};  if ischar(v3) v3 = v3 - '0'; end;
        if v3
          c = get(gcbo,'backg');  if c(1) == 1  c = [.2 .3 1];  else  c = [1 .2 .6]; end;
          set(gcbo,'backg',c);
          t = s{8};  i1 = abs(s2i(get(e(2,1),'str')));  i2 = abs(s2i(get(e(end,1),'str')));
          feval('assignin','base','XYindex',[i1 i2]);  lclick = ~(sum(get(gcf,'SelectionT'))==321);
          for k = 1:length(xy)
            if ~xy(k) continue; end;
            v = t{k};  x = get(lc(k),'x');  y = get(lc(k),'y');  n = length(x);  if n < i1 continue; end;
            if lclick   j2 = min(i2,n);  x = x(i1:j2);  y = y(i1:j2);  end;
            v(find(v<'0' | (v>'9' & v<'A') | (v>'Z' & v<'a') | v>'z')) = '_';  vx = ['x' v];  vy = ['y' v];
            feval('assignin','base',vx,x);  feval('assignin','base',vy,y);
          end;
        else
          e = e(:);
          if length(e)<2 nc = e; ul = {};  rd = {};
          else ul = get(e(1),'userdata');  rd = getappdata(e(1),'rd');
               delete(e);
          end;
          cc = s{7};  t = s{8};  bg = get(f,'color');  p = get(f,'pos');
          bh = (8*bg(1)+1)/10; bh = [bg(1) bh bh];
          y = p(4);  nr = floor(p(4)/18);  e = -ones(nr,nc);
          mou = 'plt misc cdw 0 0 0;';
          for r = 1:nr
            y = y - 18;  x = 5;  inc = .01;
            for k = 1:nc
              p = [x y 66 18];  x = x+70;  ck = cc(k,:);
              if r==1  ee = uicontrol('sty','text','str',t{k},'pos',p,'backg',bg,'foreg',ck,'ena','inact','buttond',mou);
              else BG = bg;
                   if k==1 fm = '%d';
                   else fm = 7;
                        if ~xy(k) BG = bh; end;
                   end;
                   ee = plt('edit',p,0,'plt misc cdw;','format',fm,'incr',inc,'backg',BG,'foreg',ck);
                   inc = -2;
              end;
              e(r,k) = ee;  setappdata(ee,'p',[r k]);
            end;
          end;
          uistack(er,'top');  set(e,'fontsi',9,'fontw','bol');
          uistack(findobj(gcf,'buttond','plt misc cdw 1;'),'top');
          if Mver<7 set(e(:,1),'fontw','nor'); else set(e(:,1),'fontw','nor','fonta','ita'); end;
          mn = length(ul);  if mn mn = sprintf('%d',mn); else mn = ''; end;
          setappdata(fp,'datacur',f);
          set(e(1,1),'str',['index' mn],'userdata',ul);
          setappdata(e(1,1),'rd',rd);
          s{3} = e;  set(f,'userdata',s);
          cur(cid,'MVcur');
        end;
      case 4,
         r = getappdata(rng(1),'p');  i1 = rng(2);  i2 = rng(4);  w = i2-i1;
         l = lc(r(2));  d = get(l,'y');
         if w<0 is = i1;  i1  = i2;  i2 = is;  w = -w; end;
         v1 = d(i1);  v2 = d(i2);  ix = i1+1:i2-1;  dix = d(ix);  dix = dix(:)';
         e1 = e(1,1);  ul = [{[r(2) 1 i1+1 dix]} get(e1,'userdata')];
%
         set(e1,'str',sprintf('index%d',length(ul)),'userdata',ul);
         for i = ix  d(i) = ((i2-i)*v1 + (i-i1)*v2)/w;  end;
         set(l,'y',d);  set(er,'vis','of','userdata',0*rng);
         cur(cid,'MVcur');
      case 5,
        e1 = e(1,1);   ul = get(e1,'userdata');  rd = getappdata(e1,'rd');
        r = getappdata(gco,'p');  mn = length(ul);  rn = length(rd);  ra = {};
        left = ~(sum(get(gcf,'SelectionT'))==321);  ll = 0;
        if r(2)==1
          if ~mn return; end;
          while 1
            u = ul{1};  l = lc(u(1));  u2 = u(2);  ix = u(3);  v2 = mod(u2,8);
            switch v2
            case 2,    i = 1:ix;  ia = ix+u(5)+1;  ll = u(4);  x = get(l,'x');  y = get(l,'y');
                       set(l,'x',x([i ia:end]),'y',y([i ia:end]));
            case 3,    x = get(l,'x');  y = get(l,'y');  ll = u(4);  u = u(5:end);
                       a = length(u);  j = ix:ix+a-1;  i = [1:ix-1 ones(1,a)];
                       x = x([i ix:end]);  y = y([i ix:end]);  x(j) = real(u);  y(j) = imag(u);
                       set(l,'x',x,'y',y);
            otherwise, if v2 xy = 'y'; else xy = 'x'; end;
                       d = get(l,xy);  k = 4:length(u);  ix = ix:ix+length(k)-1;
                       dix = d(ix);  ra = [{[u(1:3) dix(:)']} ra];
                       d(ix) = u(k);  set(l,xy,d);
            end; 
            ul(1) = [];  mn = mn-1;  if u2<8 & (left | ~mn) break; end;
          end;
          rd = [fliplr(ra) rd];   if ll  s{9} = ll;  set(f,'userdata',s);  end;
        else
          if ~rn return; end;  ua = {};
          while 1
            u = rd{1};  u2 = u(2);  v2 = mod(u2,8);  if v2 xy = 'y'; else xy = 'x'; end;
            l = lc(u(1));  d = get(l,xy);  k = 4:length(u);  u3 = u(3);  ix = u3:u3+length(k)-1;
            dix = d(ix);  ua = [{[u(1:3) dix(:)']} ua];
            d(ix) = u(k);   set(l,xy,d);  rd(1) = [];  rn = rn-1;  mn = mn+1;
            if u2<8 & (left | ~rn) break; end;
          end;
          ul = [fliplr(ua) ul];
        end;
        if mn mn = sprintf('%d',mn); else mn = ''; end;
        set(e1,'str',['index' mn],'userdata',ul);
        setappdata(e1,'rd',rd);
        set(er,'vis','of','userdata',0*rng);
        cur(cid,'MVcur');
      case 2,
        r = getappdata(gco,'p');  k = r(2); r = r(1);  e1 = e(1,1);  ul = get(e1,'userdata');
        ix = abs(plt('edit',e(r,1)));
        u = get(gco,'userdata');  a = u{6};
        if k==1
          if a == .01  setappdata(f,'cdw',plt('edit',gco)); cur(cid,'MVcur'); return;
          else
            llp = s{9};  ll = 0;  ua = {};  u{6} = .01;  set(gco,'userdata',u);
            for k = 3:length(lc)
              if ~xy(k) continue; end;
              l = lc(k);  x = get(l,'x');  y = get(l,'y');  [p q] = size(x);  n = max(p,q);
              if ix > n continue; end;
              if a>0  ua = [{[k 10 ix llp a]} ua];  iq = ix+1;
                      x1 = x(ix);  y1 = y(ix);  ai = 1:a;
                      if ix == n  dx = x1 - x(ix-1);  dy = 0;
                      else        dx = (x(iq)-x1)/(a+1);  dy = (y(iq)-y1)/(a+1);
                      end;
                      if p==1   x = [x(1:ix) x1+ai*dx x(iq:end)];  y = [y(1:ix) y1+ai*dy y(iq:end)];
                      else      ai = transpose(ai);
                                x = [x(1:ix); x1+ai*dx; x(iq:end)];  y = [y(1:ix); y1+ai*dy; y(iq:end)];
                      end;
                      
              else    iq = ix-1;  i = ix:min(iq-a,n);   sv = complex(x(i),y(i));
                      sv = transpose(sv(:));  ua = [{[k 11 ix llp sv]} ua];
                      i = [1:iq ix-a:n];    x = x(i);  y = y(i);
              end;
              set(l,'x',x,'y',y);  ll = max(length(x),ll);
            end;
            ua{end}(2) = (5 - sign(a))/2;
            s{9} = ll;  set(f,'userdata',s);
            cur(cid,'MVcur');
          end;
        else
          l = lc(k);
          if xy(k) d = get(l,'y');  ub = [k 1 ix d(ix)];  ua = {ub};
                   if length(ul)  u1 = ul{1};
                     if all(u1(1:3) == ub(1:3)) & length(u1)==4 ua = {}; end;
                   end;
                   d(ix) = plt('edit',e(r,k));  set(l,'y',d);
                   a = get(l,'par');  yl = get(a,'ylim');
                   YL = [min(min(d),yl(1)) max(max(d),yl(2))];
                   if ~isequal(yl,YL) set(a,'ylim',YL); plt('grid',a); end;
                   if length(ua)
                     rng(1:2) = rng(3:4);
                     rng(3) = gco; rng(4) = ix;  set(er,'userdata',rng);
                   end;
                   rr = getappdata(rng(1),'p');  ixd = ix-rng(2);
                   if length(rr) & k==rr(2) & ixd
%
                     if ixd == r-rr(1) y1 = get(rng(1),'pos');  y1 = y1(2);
                                       y2 = get(gco,'pos');     y2 = y2(2);
                                       Y1 = min(y1,y2);  Y2 = max(y1,y2);
                     else              Y1 = -5; Y2 = get(f,'pos'); Y2 = Y2(4)-12;
                     end;
                     set(er,'vis','on','pos',[6 Y1+10 7 Y2-Y1]);
                   else set(er,'vis','of');
                   end;
          else     ua = {};  d = get(l,'x');  dix = d(ix);  d(ix) = plt('edit',e(r,k));
                   for c = k+1:nc
                     if xy(c) ua = [{[c 8 ix dix]} ua]; set(lc(c),'x',d); else; break; end;
                   end;
                   ua{end}(2) = 0;
                   if length(ul)  u1 = ul{1};  u2 = ua{1};
                      if all(u1(1:3) == u2(1:3))  ua = {}; end;
                   end;
          end;
        end;
        CurMain = getappdata(0,'CurMain');   Hc = get(CurMain(cid),'userdata');
        if length(get(Hc(7),'userdata'))
           setappdata(fp,'NewData',1);
           figure(fp);  cur(cid);  figure(f);
        end;
        ul = [ua ul];  set(e1,'str',sprintf('index%d',length(ul)),'userdata',ul);
      end;

    case 534,
      a = getappdata(gcf,'ucreq');
      if length(a) evalQ(a); end;
      for cid=getappdata(gcf,'cid')
         cur(cid,'clear');
      end;
      if length(getappdata(gcf,'link')) closereq; return; end;
      for fk = findobj('type','fig','tag',get(gcf,'tag'))';
        if fk ~= gcf
          a = getappdata(fk,'ucreq');
          if length(a) evalQ(a); end;
          for cid=getappdata(fk,'cid')
            cur(cid,'clear');
          end; 
          delete(fk);
        end;
      end;
      closereq;
  end;

case 966
  r = 'Color';  s = r;  m = getappdata(gcbo,'m');
  if isempty(m) m = getappdata(get(gcbo,'par'),'m'); end;
  if iscell(m) hq=m; m=gcbo;
  elseif ishandle(m) hq = getappdata(m,'m');
  elseif isempty(m)
    m = gcbo;  ty = get(m,'type');
    if ~isfield(get(m),r) s = 'backgr';
%
    elseif ischar(get(m,r)) & ty(1)=='a'
      ax = getappdata(get(m,'par'),'axis');
      if length(ax)>1 m=ax(end); end;
    end;
    hq = {s m [ty ' ' s]}; 
  end;
  if Narg>1 ccf = varargin{2}; else ccf = ''; end;
  if strcmp(ccf,'C')
    for k=2:2:length(hq)
      h = hq{k};
      for j = 1:length(h) setappdata(h(j),'f',[]); end;
    end;
    setappdata(m,'f',[]);
    closereq;
    return;
  end;
  t = 0; cb = '';  f = getappdata(m,'f');
  if isempty(f)
    hb = [];  for k=2:2:length(hq) hb = [hb hq{k}]; end;
    if length(find(m==hb))
          b=m;
    else  b=hb(1); hb=[hb m];
    end;
    ed = 0;
    switch get(b,'type')
      case 'uicontrol', c = get(b,'backg');  t = get(b,'str');  ed = strcmp(get(b,'sty'),'edit');
      case 'text',      c = get(b,r);  t = get(b,'str');
      case 'patch',     c = get(b,'facecolor');
      otherwise,        c = get(b,r);
    end;
    if ischar(c) c = get(m,r);
                 if ischar(c) c = [1 1 1]/2; end;
    end;
    if ed             c = [str2num(t) 0 0 0];   c = min(max(c(1:3),0),1);
    elseif ischar(t)  t = str2num(t);  if length(t)==3 & min(t)>=0 & max(t)<=1 c=t; ed=1; end;
    end;
    if Narg<3 & ed & sum(get(gcf,'SelectionT'))~=321 & b==m
      t = ctriple(c);
      for k=2:2:length(hq)
        p = hq{k-1};  h = hq{k};
        if ~iscell(p) p = {p}; end;
        for j=1:length(p)
          q = p{j}; if strcmp(q(1:3),'str') set(h,q,t); else set(h,q,c); end;
        end;
      end;
      if length(ccf)>1 eval(ccf); end;
      return;
    end;
    f = figure('menu','none','numberT','off','back','off','pos',auxLoc(302,205,3),'color',[0,.4,.4],'name','Color Pick',...
               'tag',get(gcf,'tag'),'double','off','closereq','plt ColorPick C;');
    setappdata(f,'ccf',ccf);
    cb = 'plt ColorPick;';  s1 = [0 100 0 100];  d = round(c*100);
    p1 = [.02 .20 110];  p2 = [0 .29 0];
    s = [plt('slider',p1+2*p2,[d(1) s1],'Red (%)'  ,cb,2) ...
         plt('slider',p1+p2,  [d(2) s1],'Green (%)',cb,2) ...
         plt('slider',p1,     [d(3) s1],'Blue (%)' ,cb,2)];
    obj = plt('slider',s(1),'get','obj');  set(obj(5),'backg',[1 1 0]);
    ax = axes('xlim',[.8 12.15],'ylim',[.8 15.4],'color',[0 0 0],'xcol',[0,.4,.4],'ycol',[0,.4,.4],'XtickLabel',' ','YtickLabel',' ','TickLen',[0 0]',...
              'unit','nor','pos',[.408 .02 .57 .96]);
    if ischar(hq{end})
      text(-3.4,14.7,hq{end},'horiz','center','color',[1 .7 .8]);
    end;
    setappdata(f,'m',m);  setappdata(ax,'m',m);
    ph = zeros(11,11);
    for row = 1:11
      for col = 1:11
        ph(row,col) = patch(col+[0 1 1 0],row+[0 0 1 1],[0 0 0],'buttond',cb);
      end;
    end;
    c = d/100;
    pat = patch([1 12 12 1],12+[.5 .5 3 3],c,'buttond',cb);  setappdata(pat,'m',m);
    setappdata(f,'h',{c s pat ph ax});
    for k=1:length(hb) setappdata(hb(k),'f',f); setappdata(hb(k),'m',hq); end;
  end;
%
  h = getappdata(f,'h');
  p = get(gcbo,'par');
  s = h{2};
  if length(cb) k=1;
  else
    if strcmp(get(gcbo,'type'),'patch') & isempty(cb)
      if gcbo==h{3} c = h{1}; else c = get(gcbo,'facecolor'); end;
      for k=1:3
        obj = plt('slider',s(k),'get','obj');
        bk = get(obj(5),'backg');
        if bk(1) break; end;
      end;
    else
      try y = get(gcbo,'sty'); catch return; end;
      y = strcmp(y,'edit');
      if y & isequal(get(gcbo,'userdata'),[0 100]) y=0; end;
      if y  c = [str2num(get(gcbo,'str')) 0 0 0];  c = min(max(c(1:3),0),1);
      else  c = get(h{3},'facecolor');
      end;
      d = round(100*c);
      k = 0;
      for j=1:3
        z = plt('slider',s(j));   obj = plt('slider',s(j),'get','obj');
        if z~=d(j) & ~k bk = [1 1 0];  k = j;  if ~y d(k)=z; end;
        else            bk = [0 1 1];
        end;
        set(obj(5),'backg',bk);
      end;
      if ~k set(obj(5),'backg',[1 1 0]); return; end;
      c = d/100;
    end;
  end;
  set(h{3},'facecolor',c);
  d = round(c*100);
  for j=1:3  plt('slider',s(j),'set','val',d(j)); end;
  ph = h{4};  phc = [0 0 0];  phc(k) = d(k)/10;  v = mod(k,3)+1;  w = mod(v,3)+1;
  for row = 0:10
    phc(v) = row;
    for col = 0:10
      phc(w) = col;  set(ph(row+1,col+1),'FaceColor',phc/10);
    end;
  end;
  t = ctriple(c);
  for k=2:2:length(hq)
    p = hq{k-1};  h = hq{k};
    if ~iscell(p) p = {p}; end;
    for j=1:length(p)
      q = p{j}; if strcmp(q(1:3),'str') set(h,q,t); else set(h,q,c); end;
    end;
  end;
  ccf = getappdata(f,'ccf');
  if length(ccf)>1 eval(ccf); end;

case 755
  Ret1 = ctrip(varargin{2});
  
case 434
  if Narg<2 [fi pth] = uigetfile('plt.plt','Select plt figure to open');
            if isnumeric(fi) return; end;
            fi = [pth fi];
  else      fi = varargin{2};
  end;
  ydat = [];
  feval('load',fi,'-mat');
  if isempty(ydat)
    p = find(fi=='.');
    if length(p) f = [fi(1:p(end)) 'mat']; end;
    dos(['copy ' fi ' ' f ' > NUL:']);
    load(f); delete(f);
  end;
  xdat = [xdat'; ydat'];
  pltinit(xdat{:},params{:});
%

case 431
  if Narg<2 [fi pth] = uiputfile('plt.plt','Save plt figure as');
            if isnumeric(fi) return; end;
            fi = [pth fi];
  else      fi = varargin{2};
  end;
  lh = getappdata(gcf,'Lhandles');
  xdat = get(lh,'x');  if ~iscell(xdat) xdat = {xdat}; end;
  ydat = get(lh,'y');  if ~iscell(ydat) ydat = {ydat}; end;
  ax = get(lh(1),'par');  xlm =  get(ax,'xlim');   ylm =  get(ax,'ylim');  ylR = [];
  for k = 1:length(lh)
    ax = get(lh(k),'par');  xm = getappdata(ax,'xmult');  ym = getappdata(ax,'ymult');
    if strcmp(get(ax,'YAxisLoc'),'right')  ym = 1;  ylR = get(ax,'ylim');  end;
    if length(xm) & xm ~= 1  xdat{k} = xdat{k}*xm;  if k==1 xlm = xlm*xm; end; end;
    if length(ym) & ym ~= 1  ydat{k} = ydat{k}*ym;  if k==1 ylm = ylm*ym; end; end;
  end;
  figname = [get(gcf,'name') ' (saved)'];  dis = ~isVIS(lh)';
  params = [getappdata(gcf,'params') {'pos' get(gcf,'pos') '+' 0 'FigName' figname 'DIStrace' dis 'Xlim' xlm 'Ylim' ylm}];
  if length(ylR) params = [params {'YlimR' ylR}]; end;
  ver = '14Sep23';
  save(fi,'xdat','ydat','params','ver');
%

case 518
  if MverE  ERAS = 'eras';  ERAXOR = 'xor';  ERANOR = 'norm';
  else      ERAS = 'pi';    ERAXOR = 'v';    ERANOR = 'v';
  end;
  y2 = varargin{2};
  if ischar(y2)
    AX = findobj(gcf,'tag','click');
    y2s = sum(y2);
    if y2s == 511
      AX = getappdata(gcf,'axis');
      hpop = getappdata(gcf,'epopup');
      hd = getappdata(hpop,'EdHide');
      if nargin==2 ix = plt('pop',hpop);
                   cb = get(hd(1),'callback');
                   if ~iscell(cb) return; end;
                   CurID = cb{2};
                   if length(AX)>1 AX = findobj(gcf,'YAxisLoc','left','userdata',CurID); end;
      else         ix = varargin{3};
                   if ischar(ix) ix = s2i(ix); end;
                   if length(AX)>1
                     if strcmp(get(gcbo,'type'),'figure')
                        xva = findobj(gcf,'buttond','plt click Yedit 3 0;');  CurID = s2i(get(xva(1),'tag'));
                     else  CurID = [];  gtag = get(gcbo,'tag');  if ischar(gtag) CurID = s2i(gtag); end;
                           if isempty(CurID) | ~isnumeric(CurID)
                             CurID = get(gca,'userdata');
                             if isempty(CurID) | ~isnumeric(CurID) | mod(CurID,1)
                               CurID = getappdata(gcf,'cid');  CurID = CurID(1);
                             end;
                           end;
                     end;
                     AX = findobj(gcf,'YAxisLoc','left','userdata',CurID);
                   end;
      end;
    end;
    if y2s ~= 427
      if length(AX)>1
         a = getappdata(gcbo,'AX');
         if length(a)==1 AX = a;
         else 
           a = gca;  yal = get(a,'YAxisLoc');
           if yal(1)=='r' a = findobj(gcf,'YAxisLoc','left','userdata',get(a,'userdata')); end;
           fi = find(a==AX);
           if length(fi)==1 AX = AX(fi);
           else  a = getappdata(gcf,'cidP');
                 if length(a) [n AX] = cur(a,'getActive'); AX = get(AX,'par');
                 else         AX = AX(end);
                 end;
           end;
         end;
      end;
      CurID = get(AX,'userdata');
      AX2   = findobj(gcf,'YAxisLoc','right','userdata',CurID);
      AXrl  = [AX AX2];
      if isempty(AX2) AX2 = -1; end;
      CurMain = getappdata(0,'CurMain');  Hc = get(CurMain(CurID),'userdata');
    end;

    switch y2s
    case 430
      h = get(AX2,'ylab');  s = get(h,'str');
      if s(1)==92 & s(2)=='d'  s = s(6:end-5);
      else                             s = ['\div ' s ' \div'];
      end;
      set(h,'str',s);

    case 427
      in3 = varargin{3}; if ischar(in3) in3 = s2i(in3); end;
      if in3<0
        cid = -in3;  g = gcf;  as = gca;  [n lh] = cur(cid,'getActive');
        h = cur(cid,'obj');   ax = h(13);  ar = h(14);  if isempty(get(ar,'parent')) ar = []; end;
        nL = length(getappdata(ax,'Lhandles'));  axtid = h(16);
        tid = cur(cid,'TraceIDs');  nt = length(tid);
        if nL==1  if nt ~= 1 tid = get(get(ax,'ylab'),'str'); end;
        else      while nt<nL  nt=nt+1;  tid = [tid; {sprintf('Line %d',nt)}]; end;
                  tid = [tid; {'ALL LINES'}];
        end;
        tx = [];  hb = [];
        if length(get(axtid,'par'))
              t = flipud(get(axtid,'child'));
              tx = findobj(t,'type','text');
              t = findobj(t,'type','line');
              bt = get(t,'button');
              if iscell(bt) hb = t(find(cellfun('length',bt))); end;
        end;
        figure('menu','none','numberT','off','back','off','resize','off','pos',auxLoc(302,195),'color',[0,.4,.4],'name','Properties','tag',get(gcf,'tag'),...
               'closereq','plt click mark 4;');
        pu0 = uicontrol('sty','pop','str', tid,'pos',[45 167 220 20],'val',n,'callback','plt click mark 9;','userdata',cid);
        props = 'Color|LineStyle|LineWidth|Marker|MarkerSize|Xdata|Ydata|Zdata';
        ps = 'Figure background|Plot background|Axis color|Axis color (right)|Axis label colors|Delta cursor color|Grid color|Grid style';
        callp = 'plt click mark 10;';
        calle = 'plt click mark 11;';
        callc = 'plt click mark 13;';
        ed1 = uicontrol('sty','edit','pos',                 [  8  80 130 22],'fontw','bol','callback',calle,'buttond',calle,'userdata',{tx hb});
        pu1 = uicontrol('sty','pop','str',props,'pos',          [  8 110 130 20],'callback',callp);
        uicontrol('sty','text','str', 'Line properties:','pos',   [  8 140 130 17],'backg',[1 1 .6]);
        ed2 = uicontrol('sty','edit','pos',                 [145  80 150 22],'fontw','bol','callback',calle,'buttond',calle);
        pu2 = uicontrol('sty','pop','str',props,'pos',          [145 110 150 20],'callback',callp,'val',5);
        uicontrol('sty','text','str', 'Cursor properties:','pos', [145 140 150 17],'backg',[1 1 .6]);
        pu3 = uicontrol('sty','pop','str',ps,'pos',             [  8  40 160 20],'callback','plt click mark 12;');
        ed3 = uicontrol('sty','edit','pos',                 [  8   8 160 22],'fontw','bol','callback',callc,'buttond',callc);
        uicontrol('str','Save color scheme','pos',[180  22 115 22],'callback','plt click mark 3;');
        setappdata(ed1,'pop',pu1); setappdata(pu1,'edt',ed1);
        setappdata(ed2,'pop',pu2); setappdata(pu2,'edt',ed2);
        mb = findobj(g,'tag','MenuBox')';
        gr = findobj(g,'user','grid');  gr = gr(1);
        setappdata(ed3,'m',{'str',ed3,'color',[g mb],'Figure background'});
        setappdata(ed3,'pop',pu3); setappdata(pu3,'edt',ed3); setappdata(pu3,'obj',[]);
        set(ed3,'str',ctriple(get(g,'color')));
        if ischar(get(ax,'color')) ap = ar; else ap = ax; end;
        lb = [get(ax,'xlab') get(ax,'ylab')];
        if length(mb)==1  lb = [lb get(mb,'child')']; end;
        dc = findobj(g,'tag','DeltaC');
        set(pu3,'userdata',{[g mb];
                      ap;
                      ax;
                      ar;
                      lb;
                      dc(1)
                      gr
                      gr
                     });
        h = [pu0 ed1 pu1 ed2 pu2 ed3 pu3];
        set(h,'backg',[1 1 1]*.75,'foreg',[0 0 0]);
        set(h([2 4 6]),'backg',[.6 1 1]);
        set(gcf,'userdata',h);
        plt click mark 9;
        axes(as);
        return;
      end;

      switch in3
        case 9,
          h = get(gcf,'userdata');  [pu0 ed1 pu1 ed2 pu2] = dealv(h);  cid = get(pu0,'userdata');
          hb = get(ed1,'userdata');  tx = hb{1};  hb = hb{2};
          n = get(pu0,'val');  nn = length(get(pu0,'str'));
          [xy k] = cur(cid,'get');
          c = [];  lh = [];  tid = [];  a = [];
          if n==nn & nn>2  jj = 1:n-1;
          else             jj = n;
          end;
          for j = jj
            cur(cid,'setActive',j,-k);
            ob = cur(cid,'obj');   cc = ob(15);
            l = get(cc,'userdata');  lh = [lh l{1}];  c = [c cc];
            ax = ob(13);
            if length(tx) >= j  tid = [tid tx(j)];  elseif isempty(tx) a=ax; tid = [tid get(ax,'ylab')]; end;
            if length(hb) >= j  tid = [tid hb(j)]; end;
          end;
          setappdata(pu1,'obj',lh);  setappdata(pu2,'obj',c);
          setappdata(ed1,'m',{'str',ed1,'color',[lh tid],'ycolor',a,'Line color'});
          setappdata(ed2,'m',{'str',ed2,'color',c,'Cursor color'});
          set(ed1,'str','*');  plt click mark 10;
          plt click mark 10;
        case 10,
           p = gcbo;
           h = get(gcf,'userdata');  pu1 = h(3);  pu2 = h(5);
           if isempty(p) | (p~=pu1 & p~=pu2)
              s = get(h(2),'str');  if s(1)=='*' p = pu1;  else p = pu2; end;
           end;
           e = getappdata(p,'edt');
%
           m = getappdata(e,'m'); obj = m{4}(1);
           c = get(p,'str');   v = get(p,'val');  prop = deblank(c(v,:));
           f = getappdata(e,'f');  if length(f) close(f); end;
           if strcmp(prop,'Delete') & ishandle(obj) delete(obj); end;
           if ishandle(obj)
             s = get(obj,prop);
             if isnumeric(s)
                if length(s)==3 & max(s)<=1 & min(s)>=0 s = ctriple(s);
                else                                    s = num2str(s);
                end;
             end;
             set(e,'str',s);
           else set(e,'str','Deleted');
           end;
        case 11,
           e = gcbo;  p = getappdata(e,'pop');
           m = getappdata(e,'m'); obj = m{4};
%
           c = get(p,'str'); v = get(p,'val');   prop = deblank(c(v,:));
           s = get(e,'str'); f = get(e,'userdata');
           if sum(get(gcf,'SelectionT'))==321 if strcmpi(prop,'Color') plt('ColorPick'); end;
                         return;
           end;
           switch prop
           case 'Delete',
             if strcmpi(s,'all')
               if length(c(:,1))==9 c='line'; else c='text'; end;
               h = get(gcf,'userdata');  ax = get(h(1),'userdata');  delete(findobj(ax,'type',c,'tag','mark'));
             end;
           case 'Color',  plt('ColorPick');
           case {'Xdata','Ydata','Zdata'},
                      s = str2num(s);  n = length(s); xy = char('X' + (prop(1)=='X'));
                      for k=1:length(obj)
                        if strcmp(get(obj(k),'type'),'line') & length(get(obj(k),xy))==n set(obj(k),prop,s); end;
                      end;
           otherwise, if isnumeric(get(obj(1),prop)) s = str2num(s); end;
                      if size(get(p,'str'),1)<11 obj = findobj(obj,'type','line'); end;
                      set(obj,prop,s);
           end;
         case 12,
           p = gcbo;  e = getappdata(p,'edt');  v = get(p,'val');  f = get(e,'userdata');
           h = get(p,'userdata');  h = h{v};  if length(h) h1 = h(1); else return; end;
           pr = {'color' 'color' {'xcol' 'ycol'} 'ycol' 'color' 'color' 'color' 'linest'};
           pr = pr{v};
           if iscell(pr) s = get(h1,pr{1}); else s = get(h1,pr); end;
           if ~ischar(s) s = ctriple(s);  end;
           set(e,'str',s);
           f = getappdata(e,'f');  if length(f) close(f); end;
           s = get(p,'str');
           setappdata(e,'m',{'str',e,pr,h,deblank(s(v,:))});
        case 13,
           s = get(gcbo,'str');
           v = get(getappdata(gcbo,'pop'),'val');
           if v==8
             h = get(gcf,'userdata');  pu3 = h(7);  u = get(pu3,'userdata');  g = u{1}(1);
             gr = findobj(g,'user','grid'); gr = gr(1);
             set(gr,'linest',s);
           else plt ColorPick;
           end;
        case 14,
           s = get(gcbo,'str');
           if s(1)=='D' set(gcbo,'str','click again if you are sure'); return; end;
           f = get(gcbo,'userdata');
           delete([findobj(f,'tag','mark'); findobj(f,'tag','markR')]);
           close(gcf);
        case 3,
%
          h = get(gcf,'userdata');  pu3 = h(7);  u = get(pu3,'userdata');  g = u{1}(1);
          AX = u{3};  AX2 = u{4};
          cFIGbk = get(g,'color');
          cPLTbk = get(AX,'color');
          if isstr(cPLTbk) cPLTbk = get(AX2,'color'); end;
          cXYax  = get(AX,'xcol');
          cXYlbl = get(get(AX,'xlab'),'color');
          cDELTA = findobj(g,'tag','DeltaC'); cDELTA = get(cDELTA(1),'color');
          cTRACE = get(getappdata(g,'Lhandles'),'color');
          cTRACE = reshape([cTRACE{:}],3,length(cTRACE))';
          cFile = findobj(g,'style','push','str','D');  cFile  = get(cFile(end),'tag');
          gr = findobj(g,'user','grid');  gr = gr(1);        cGRID  = getappdata(gr,'clr');
          GridSty = get(gr,'linest');                GridEr = get(gr,ERAS);
          if isempty(cFile) [cFile pth] = uiputfile('*.mat','Select file for saving colors');
                            cFile = [pth cFile];
          end;
          if sum(cFile)
             save(cFile,'cFIGbk','cPLTbk','cXYax','cXYlbl','cDELTA','cTRACE');
             msgbox(['This program will now use colors saved in file ' cFile],'modal');
          else disp('No file was selected'); end;
          return;
        case 4,
          close(findobj('name','Color Pick')); 
          closereq;
          return;
      end;
    case 653
      ax = getappdata(gcf,'axis');  n = length(ax);  axr = []; axl = [];
      for k=ax  r = get(k,'YAxisLoc');
                if r(1)=='r' axr = [axr k]; else axl = [axl k]; end;
      end;
      if sum(get(gcf,'SelectionT'))==321
        r = get(ax(n),'YAxisLoc');
        if length(axr) era=ERAXOR; else era=ERANOR; end;
        for k = axl
          g = findobj(k,'user','grid');
          if isempty(g) | isempty(deblank(get(g,'tag'))) continue; end;
          c = getappdata(g,'clr');  st = get(g,'linest'); 
          inv = c(1) > .5;
          if st(1)=='-'  c = 2*c;  if inv c=c-1; end;  c=max(min(c,1),0); cc=c; er=ERANOR; sty=':';
          else           c = c/2;  if inv c=c+.5; end; c=max(min(c,1),0); cc=c; er=era;    sty='-';
          end;
          if MverE & length(axr)
            p = get(k,'pos');  mainA=0;
            for j=axr if all(get(j,'pos')==p) mainA=1; break; end; end;
            if mainA  if isVIS(j) gx = get(gcf,'color'); else gx = get(j,'color'); end;
                      c = bitxor(round(255*c),round(255*gx))/255;
            end;
          end;
          setappdata(g,'clr',cc);
          set(g,'linest',sty,'color',c,ERAS,er);
        end;
      else
        for k=axl
          g = findobj(k,'user','grid');
          if isempty(g) | isempty(deblank(get(g,'tag'))) continue; end;
          plt('grid',k,'toggle');
        end;            
      end;
    case 410
      if sum(get(gcf,'SelectionT'))==321
        f = get(gcf,'menu');
        if   f(1)=='f' delete(findobj(gcf,'type','uimenu')); set(gcf,'menu','none');
        else set(gcf,'menu','fig');
             if ~MverE | Mver<7
               cbs = 'cur(getappdata(gcf,"cidP"),"rstyle");';
               lbs = '<1>&Toggle magnifying lens mode (<2>t<3>) <4>Rclick "o"<5>';
             else
               cbs = 'plt misc smoothtog;';
               lbs = '<1>&Toggle line smoothing (<2>t<3>)';
             end;
             m = uimenu('label','&plt');
             cb1 = 'a=getappdata(gcf,"axis"); a=a(1); if getappdata(a,"DualCur") b=0; ';
             cb2 = 'set(findobj(gcf,"buttond","plt click EDIT 6 3;"),"vis","of"); ';
             cb3 = 'else b=cur(get(a,"user"),"getActive",0); end; setappdata(a,"DualCur",b);';
             cb = {'plt help;' ...
                   'plt save;' ...
                   'plt open;' ...
                   'plt("click","mark",-getappdata(gcf,"cidP"));' ...
                   'plt xleft data;' ...
                   'plt cright 0 TGLlogx;' ...
                   'plt("hcpy","init",gcf);' ...
                   'plt hidecur;' ...
                   'plt hidetid;' ...
                   cbs ...
                   [cb1 cb2 cb3] ...
                   'plt move;' ...
                   'plt move res;' };
             lb = {'<1>plt H&elp (<2>e<3>)' ...
                   '<1>plt &Save (<2>s<3>)' ...
                   '<1>plt &Open (<2>o<3>)' ...
                   '<1>plt &Properties (<2>p<3>) <4>Properties in Ypopup<5>' ...
                   '<1>&Cursor Data Window (<2>c<3>) <4>menubox data tag<5>' ...
                   '<1>S&wap X/Y axes (<2>w<3>) <4>Rclick LinX<5>' ...
                   '<1>&Hardcopy (<2>h<3>) <4>Rclick LinY<5>' ...
                   '<1>H&ide/Show cursor controls (<2>i<3>)  <4>Rclick Yaxis label<5>' ...
                   '<1>Hide/Show TraceID &box (<2>b<3>)' ...
                   lbs ...
                   '<1>Set d&ual cursor (<2>u<3>)' ...
                   '<1>Toggle &Reposition mode (<2>r<3>)  <4>Rclick Delta<5>'...
                   '<1>SnapTo &Grid size (<2>g<3>) <4>Delta+Rclick Delta<5>' };
             sp = {'of' 'of' 'of' 'on' 'of' 'of' 'of' 'of' 'of' 'of' 'of' 'on' 'of'};
             rp = {'<1>' '<html>' '<2>' '<u>' '<3>' '</u>' '<4>' '<font color="blue"><i>' '<5>' ''};
             if Mver<7 rp = {'<1>' '' '<2>' '' '<3>' '' '<4>' '[' '<5>' ']'}; end;
             for k=1:length(cb)
               s = lb{k};
               for j=1:2:length(rp) s = strrep(s,rp{j},rp{j+1}); end;
               uimenu(m,'label',s,'callback',strrep(cb{k},'"',''''),'sep',sp{k});
             end;
        end;
      else
        cf = gcf;  l = getappdata(AX,'Lhandles');
        tn = cur(CurID,'TraceIDs');
        axS = getappdata(AX,'axS');
        for k = 1:length(axS)
          l = [l; getappdata(axS(k),'Lhandles')];  ylbl = get(get(axS(k),'ylab'),'str');
          ylbl = fliplr(deblank(fliplr(ylbl)));
          while length(tn) < length(l) tn = [tn; {ylbl}]; end;
        end;
        if isempty(l) disp('No data to display'); return; end;
        x = [];
        nc = 1;
        np = 0;
        lc = 0;
        xy = 0;
        ll = 0;
        for k = 1:length(l)
           bg = get(get(l(k),'par'),'color');
           if isnumeric(bg) break; end;
        end;
        cc = [1 1 1]/2;
        clrx = cc + .2 - .4*bg(1);
        t{1} = 'index';
        for k = 1:length(l)
          lk = l(k);  if strcmp(get(lk,'vis'),'off'); continue; end;
          if length(findobj(lk,'tag','SkipCur')) | strcmp(get(lk,'tag'),'NoEdit')  continue; end;
          lk = l(k);  xx = get(lk,'x');  nn = length(xx);
          if ~nn | (nn==1 & isnan(xx)) continue; end;
          ix = [1 min(nn,2) max(1,nn-1) nn]; xxi = xx(ix);
          if nn~=np | ~isequalNaN(xp,xx)
            np = nn;  xp = xx;  ll = max(ll,nn);
            nc = nc+1; t = [t {'X'}];  lc = [lc lk];  xy = [xy 0];
            cc = [cc; clrx];
          end;
          nc = nc+1;
          if length(tn)>=k s = tn{k};  else s = 'Y'; end;
          if iscell(s) s = s{1}; end;
          if length(s) if s(1)==']' s = s(2:end); end;
                       if length(s)>9 s = s(1:9); end;
          else s = 'Y';
          end;
          t = [t {s}];  lc = [lc lk];  xy = [xy 1];
          cc = [cc; get(lk,'color')];
          if length(cc) > 39 break; end;
        end;
        w = 70*nc + 9;
        sz = get(0,'screens');  p = get(cf,'pos');
        if p(3)<1 p = p .* sz([1 2 1 2]); end;
        x1 = p(1) + p(3) + 12;  wa = sz(3) - x1;
        if p(1) > wa  x1 = 5;  wa = p(1)-5; end;
        y1 = p(2);  ha = p(4);
        if wa > w
          if x1==5 x1=wa-w-7; end; wa=w;
        else
          Y1 = p(2) + p(4) + 35;  Ha=sz(4)-Y1-80;
          if p(2) > Ha+80  Y1=59; Ha=p(2)-94; end;
          if (Ha>400) | ((Ha>200) & (sz(4)>w))
            ha = Ha; y1 = Y1; x2 = sz(4)-20; wa = min(x2,w);
            x1 = x2-wa;  x1 = x1 - min(x1,x2-p(1)-p(3));
          elseif wa<210 wa = min(w,sz(4)-10); x1=5;
          end;
        end;
        maxnr = ha/18;
        nr = min([maxnr ll+1 25]);
        hb = 18*nr;  y1 = y1 + ha - hb;
        pos = [x1 y1 wa hb];
        e = nc;
        f = findobj('type','figure');
        for k = length(f):-1:1 if all(pos == get(f(k),'pos')) pos = pos + [12 12 0 0]; end; end;
        f = figure('menu','none','numberT','off','back','off','name',get(cf,'name'),'pos',pos,'color',bg,'tag',get(gcf,'tag'));
        uicontrol('style','text','backg',[1 .2 .6],'pos',[wa-8 3 7 10],...
                  'ena','inact','buttond','plt misc cdw 1;');
        er = uicontrol('style','frame','backg',[1 1 1]/2,'vis','of','ena','inact',...
             'userdata',[0 0 0 0],'buttond','plt misc cdw 0 0;');
        set(f,'userdata',{lc xy e [AX axS] er CurID cc t ll},'ResizeF','plt misc cdw 0;');
        plt misc cdw 0;
      end;

    case 242
      p = findobj(gcf,'buttond','plt click RMS;')';
      if length(p)>1 for pp=p if pp==gcbo p = pp; break; end; end;
                     AX = get(p,'userdata');  CurID = get(AX,'userdata');
                     Hc = get(CurMain(CurID),'userdata');
      end;
      misc = get(Hc(4),'userdata');
      lH = get(Hc(15+misc(4)),'userdata');
      hix = Hc(4);  hiy = Hc(6);  hix2 = Hc(5);  hiy2 = Hc(7);
      x = get(lH{1},'x');  y = get(lH{1},'y');
      xlim = get(Hc(14),'xlim');
      xx = find(x >= xlim(1)  &  x <= xlim(2));
      y = y(xx); y = y(~isnan(y)); ly = length(y);
      ps = get(p,'str');
      switch sum(ps)
        case 286,  s = 'RMS'; r = Pftoa('%7w',sqrt(sum(y.^2)/ly));
        case 242,  s = 'y/x';
                    xr = s2d(get(hix,'str'));
                    r = getappdata(p,'idcur');
                    r = Pftoa('%7w',s2d(r{2})/xr);
                    if isVIS(hiy2) & isVIS(hix2)  xr = str2num(get(hix2,'str'));
                                                  set(hiy2,'str',s2d(get(hiy2,'str'))/xr);
                    end;
        case 288,  s = '\surdx^2+y^2';
                    xr = s2d(get(hix,'str'));
                    q = getappdata(p,'idcur');
                    r = Pftoa('%7w',abs(xr + s2d(q{2})*1j));
                    if isVIS(hiy2) & isVIS(hix2)  xr = str2num(get(hix2,'str'));
                                                  set(hiy2,'str',abs(xr + s2d(q{3})*1j));
                    end;
        case 1110, r = getappdata(p,'idcur');  s = r{1}; set(hiy2,'str',r{3});  r = r{2};
        otherwise,  nwt = getappdata(gcf,'newtxt');
                    if sum(get(gcf,'SelectionT'))==321 & length(nwt)
                         setappdata(gcf,'newtxt',[]);
                         set(findobj(findobj(gcf,'user','TraceID'),'str',ps),'str',nwt);
                         set(p,'str',nwt); set(hiy,'str','');
                         return;
                    else setappdata(p,'idcur',{ps get(hiy,'str') get(hiy2,'str')});
                         s = 'Avg';
                         r = Pftoa('%7w',sum(y)/ly);
                    end;
      end;
      set(p,'str',s); set(hiy,'str',r);

    case 294
      in3 = varargin{3} - '0';
      a = getappdata(gcf,'Dedit');
      if isempty(a) return; end;
      cid = a{1};   Hc = get(CurMain(cid),'userdata');
%
%
      cid2 = get(gcbo,'tag');  Hd = [];
      if length(cid2) cid2 = s2d(cid2);
                      if length(cid2) & cid2>0 & cid2<=length(CurMain)
                         hd = CurMain(cid2);
                         if ishandle(hd) Hd = get(hd,'userdata');  end;
                      end;
      end;
      switch in3
      case 1,
        if length(Hd) & isVIS(Hd(12))
          plt click EDIT 6 0;
          return;
        end;
        if ishandle(a{3}) & length(get(a{3},'buttond')) return; end;
        misc = get(Hc(4),'userdata');
        hact = Hc(15 + misc(4));
        a{9} = misc(1);
        m = get(hact,'marker'); a{4} = m(1)+0;
        ix = a{2};
        if a{3}~=hact
          if ishandle(a{3}) a{3} = hact;  a{7} = 0;
                            if ix<4 ix=ix+3; a{2}=ix; end;
          else a{3} = hact;
          end;
        end;
        setappdata(gcf,'Dedit',a);
        b = 'plt click EDIT 3;';
        if ix<4 fc = get(hact,'color'); else fc = 'auto'; end;
        mk = 'd>^d>^';  msz = getappdata(gcf,'EditCur');
        set(hact,'marker',mk(ix),'markerface',fc,'markersize',msz,'buttond',b);
      case 2,
        if length(Hd) & isVIS(Hd(12))
          plt click EDIT 6 2;
          return;
        end;
        hd = [findobj(gcf,'style','edit','vis','on'); findobj(gcf,'user','grid')];
        set(hd,'vis','of');
        gc = findobj(hd,'buttond','plt click EDIT 2;');
        if length(gc)>1 gc = gco; end;
        fd = find(hd==gc);
        if length(fd) hd(fd) = [];  hd = [gc; hd]; end;
        hpop = getappdata(gcf,'epopup');
        setappdata(hpop,'EdHide',hd);
        pe = get(gc,'pos');  pa = get(hpop,'par');
        set(pa,'pos',[pe(1) .01 .13 .45]);
        set(gcf,'SelectionT','normal');
        evalQ(get(hpop,'buttond'));
        set(findobj(pa,'str','Undo'),'color',[0 0 0],'fontw','bol');
      case 3, set(gcf,'WindowButtonMotionFcn','plt click EDIT 4;',...
                      'WindowButtonUpFcn',['set(gcf,''WindowButtonMotionFcn'','''',''WindowButtonUpFcn'','''');' ' plt click EDIT 5;']);
      case 4,
        i = mod(a{2},3);
        fmt = get(Hc(3),'userdata');
        y = get(get(a{3},'par'),'currentp'); x=y(1,1); y=y(1,2);
        x = round(x/a{10})*a{10};  y = round(y/a{11})*a{11};
        if i~=2 set(a{3},'y',y); set(Hc(6),'str',Pftoa(fmt(2,:),y)); end;
        if i~=0 set(a{3},'x',x); set(findobj(gcf,'sty','edit','str',get(Hc(4),'str')),...
                                                'str',Pftoa(fmt(1,:),x));
        end;
        m = getappdata(gca,'MotionEdit');
        if length(m)  if ischar(m)     feval(m,a);
                      elseif iscell(m) m = [m {a}]; feval(m{:});
                      else             m = {m a};   feval(m{:});
                      end;
        end;
      case 5,
        ix = a{2};  hact = a{3};  if ~ishandle(hact) return; end;
        lh = get(hact,'userdata');  lk = lh{1};
        xy = getxy(lk);  i = a{9};  xy1 = getxy(hact);
        if ix<4 ilast = a{7};
                xy0 = xy(ilast);
                inc = 1 - 2*(ilast>i);  dxy = (xy1-xy0)/max(1,abs(ilast-i));
                for k = ilast:inc:i xy(k)=xy0; xy0=xy0+dxy; end;
        else    if sum(get(gcf,'SelectionT'))==321
                  co = cur(cid,'obj');  ye = find(get(co(2),'str') == [168 62 68]);
                  if isempty(ye) xy = xy([1:i i i+1:end]); end;
                end;
                xlim = get(hact,'par');  ylim=get(xlim,'ylim'); xlim=get(xlim,'xlim');
                if real(xy1)<xlim(1) | real(xy1)>xlim(2) | imag(xy1)<ylim(1) | imag(xy1)>ylim(2)
                      xy(i) = [];
                else  xy(i) = xy1;
                end;
        end;
        setxy(lk,xy); setappdata(gcf,'NewData',i);
        if (Narg==4 & mod(a{2},3)==1) return; end;
        a{7} = i;  a{8} = hact;  setappdata(gcf,'Dedit',a);
        set(a{3},'marker',char(a{4}),'markerface','auto','markersize',a{5});
        cur(cid,'update',i);
        es = getappdata(gcf,'EditStop');
        if length(es) if ischar(es)     feval(es,a);
                      elseif iscell(es) es = [es {a}]; feval(es{:});
                      else              es = {es a};   feval(es{:});
                      end;
        end;
        set(a{3},'buttond','');
      case 6,
        in4 = varargin{4} - '0';
        e = zeros(1,4);  e(in4+1) = 1;
        h = Hd(4:7);  v = get(h,'str');
        v=[v v]'; v(2,:)={' '}; v=s2d([v{:}])';
        limy = Hd(14);
        limx = get(limy,'xlim');  limy = get(limy,'ylim');
        mnxy = [diff(limx)/300 diff(limy)/300];
        lim = [limx limy];  spd = mnxy/100;
        p = get(0,'PointerLoc');
        r = get(gcbo,'pos');  r = r(1) + [0 r(3)];
        if r(1)<1 fp = get(gcf,'pos');  r = r*fp(3); end;
        q = get(gcf,'currentp');
        if min(abs(q(1) - r)) < 5 e=1+0*e; end;
        f = gcf;  setappdata(f,'bdown',1);
        set(f,'WindowButtonUpFcn','setappdata(gcf,''bdown'',0);');
        if length(v)<4 return; end;
        while getappdata(f,'bdown')
          q = spd .* (get(0,'PointerLoc')-p);
          if e(1) v(1) = min(max(v(1)+q(1),lim(1)),v(2)-mnxy(1)); set(h(1),'str',Pftoa('%7w',v(1))); end;
          if e(2) v(2) = max(min(v(2)+q(1),lim(2)),v(1)+mnxy(1)); set(h(2),'str',Pftoa('%7w',v(2))); end;
          if e(3) v(3) = min(max(v(3)+q(2),lim(3)),v(4)-mnxy(2)); set(h(3),'str',Pftoa('%7w',v(3))); end;
          if e(4) v(4) = max(min(v(4)+q(2),lim(4)),v(3)+mnxy(2)); set(h(4),'str',Pftoa('%7w',v(4))); end;
          set(Hd(12),'x',v([1 2 2 1 1]),'y',v([3 3 4 4 3]));
          mZoom(v); pause(.02);
        end;
      end;

    case 511
      a = getappdata(gcf,'Dedit'); a3 = a{3};
      switch ix
      case 1,
        if getappdata(gcf,'indep')>0 cid = getappdata(gcf,'cidP');
        else;                        cid = CurID;
        end;
         plt('click','mark',-cid);
         if sum(get(gcf,'SelectionT'))==321 disp('Future right click action'); end;
      case 2,
         multi = getappdata(AX,'multi');
         if length(multi) delete(multi); setappdata(AX,'multi',[]);
                          if sum(get(gcf,'SelectionT'))~=321 return; end;
         end;
         Lha = getappdata(AX,'Lhandles'); Lhav = get(Lha,'vis');
         n = length(Lha);  cL = get(Lha,'color');
         c = (get(Lha(1),'color') + get(Lha(min(n,4)),'color'))/2;
         nn = zeros(1,n);  nnn = [nn; nn];  par = get(Lha,'par');
         tx = text(nn,nn,'');
         x = get(Lha(cur(CurID,'getActive')),'x');  if length(x)<3 return; end;  x12 = x([1 2 end]);
         for k=1:n
           x = get(Lha(k),'x');
           if length(x)<3 | ~all(x([1 2 end])==x12) Lhav{k} = 'off'; end;
         end;
         pr1 = {'par'};  cl1 = {'color'};  vl1 = {'vis'};
         if n<2 pr1 = pr1{1};  cl1 = cl1{1};  vl1 = vl1{1}; end;
         set(tx,pr1,par,'unit','data',cl1,cL,'tag','  %7w',vl1,Lhav); 
         mr = line(nnn,nnn,'color',c,'marker','o');
         set(mr,pr1,par,vl1,Lhav);
         vl = line([0 0],1e9*[-1 1],'color',c,'linest',':','par',AX);
         mc = [tx; mr; vl];  set(mc,'buttond',get(AX,'buttond'));
         p = getappdata(gcf,'mcProps');
         for k = 1:2:length(p)
           prop = p{k};  prp = prop(2:end); val = p{k+1};
           switch prop(1)
             case '|',  set(vl,prp,val);
             case '+',  if iscell(val) prp  = {prp};  end; set(mr,prp,val);
             otherwise, if iscell(val) prop = {prop}; end; set(tx,prop,val);
           end;
         end;
         setappdata(AX,'multi',mc);  cur(CurID,'update');
      case 3,
         xView = getappdata(AX,'xView');
         if nargin<4
           if length(xView) l = xView{1};  delete([l get(l,'par')]);
                            set(AXrl,'pos',xView{2});
                            setappdata(AX,'xView',[]);
                            return;
           end;
           hL = getappdata(AX,'Lhandles');  minx=+inf;  maxx=-inf;
           for i=1:length(hL) x = get(hL(i),'x');  minx  = min(minx,min(x));  maxx  = max(maxx,max(x));  end;
           xlm = [minx maxx];   if length(xlm) ~= 2 return; end;
           p = get(AX,'pos');  g = get(gcf,'pos');  g = g(4);
           c1 = get(gcf,'color');  c2 = get(AXrl(end),'color');  d = c2 > 0.5;
           p2 = p - [0 0 0 20/g];  set(AXrl,'pos',p2);
           vs = 30 - 20*isempty(get(get(AX,'title'),'str'));
           p3 = p2 + [0 p2(4)+vs/g 0 12/g-p2(4)];
           lx = get(AX,'xlim');  dlx = mean(lx) + diff(lx)*[-1 1]./16;
           v = axes('pos',p3,'xlim',xlm,'ylim',[1 3],'color',c2,'xcol',c2,'ycol',c1,'XtickLabel',' ','YtickLabel',' ','TickLen',[0 0]','buttond','plt click Yedit 3 0;');
           l = line(lx,[2 2],'color',c2 + .33*(~d - d),'linewidth',16,'buttond','plt click Yedit 3 1;','userdata',dlx);
           set([v l],'tag',sprintf('%d',CurID));
           if ~MverE set(v,'clippingStyle','rectangle'); end;
           r = getappdata(gcf,'xvProps');
           for k = 1:2:length(r)
             prop = r{k};  val = r{k+1};
             if prop(1) == '+'  prop(1)='';  if isempty(prop) prop='pos'; val = val+p3; end;
                                set(v,prop,val);
             else               set(l,prop,val);
             end;
           end;
           setappdata(AX,'xView',{l p 0});
           axes(AX);
         else
           if isempty(xView) disp('Error in plt: xView not found'); return; end;
           l = xView{1};  v = get(l,'par');  x = get(v,'currentp');  x = x(1,1);  lx = get(l,'x');
           v4 = varargin{4}-'0';  if v4==1 & sum(get(gcf,'SelectionT'))==321 v4=0; end;
           switch v4
             case 0,
                     lx((x>mean(lx))+1) = x;  x = lx;
                     set(gcf,'WindowButtonMotionFcn','plt click Yedit 3 2;','WindowButtonUpFcn','set(gcf,''WindowButtonMotionFcn'','''',''WindowButtonUpFcn'','''');');
             case 1,
                     if sum(get(gcf,'SelectionT'))==434 x = get(v,'xlim');
                                 if lx(1)>x(1) | lx(2)<x(2) set(l,'userdata',lx); else x = get(l,'userdata'); end;
                     else xView{3} = x-lx(1);  setappdata(AX,'xView',xView); x=lx;
                          set(gcf,'WindowButtonMotionFcn','plt click Yedit 3 3;','WindowButtonUpFcn','set(gcf,''WindowButtonMotionFcn'','''',''WindowButtonUpFcn'','''');');
                     end;
             case 2, lx((x>mean(lx))+1) = x;  x = sort(lx);
             case 3, x = x-xView{3};  x = [x x+diff(lx)];
           end;
           set(l,'x',x);  set(AXrl,'xlim',x);
           axes(AX); AXeval(Hc(5));
         end;
      case 4,
        if ishandle(a3)
          set(a3,'marker',char(a{4}),'markerface','auto','markersize',a{5},'buttond','');
          lh = get(a3,'userdata');  setxy(lh{1},a{6});
          a{3} = -1;  a{6} = [];  setappdata(gcf,'Dedit',a);
        end;
      otherwise,
        b = 'plt click EDIT 3;';
        if ishandle(a3) & strcmp(b,get(a3,'buttond')) plt click EDIT 5; end;
        ix = ix - 4;
        if sum(get(gcf,'SelectionT'))==321 & ix>3 & nargin<4
          h = cur(CurID,'obj'); h = h(2);  s = [168 62 68];  s = char(s(ix-3));
          pr = {'str' 'fontn'}; of = getappdata(h,'of');
          if length(of) set(h,pr,of); rmappdata(h,'of');
          else setappdata(h,'of',get(h,pr));  set(h,pr,{s 'symbol'});
          end;
          return;
        end;
        Hc = get(CurMain(CurID),'userdata');  misc = get(Hc(4),'userdata');
        hact = Hc(15 + misc(4));
        ax = get(hact,'par');
        un = get(ax,'units');  px = strcmp(un,'pixels');
        if ~px set(ax,'unit','pix'); end;  sz = get(ax,'pos');
        if ~px set(ax,'units',un); end;
        eRes = getappdata(ax,'eRes');  if isempty(eRes) eRes = [1 1]; end;
        xl = get(ax,'xlim');  dx = eRes(1)*abs(diff(xl))/sz(3);
        yl = get(ax,'ylim');  dy = eRes(2)*abs(diff(yl))/sz(4);
        ex = 10^floor(log10(dx));  dx = dx/ex;
        ey = 10^floor(log10(dy));  dy = dy/ey;
        if dx>5 dx=5;  elseif dx>2 dx=2; else dx=1; end;  dx = dx*ex;
        if dy>5 dy=5;  elseif dy>2 dy=2; else dy=1; end;  dy = dy*ey;
        if ix<4 & hact~=a{8}
          ix=ix+3;
        end;
        m = get(hact,'marker'); m = m(1)+0;
        i = misc(1);
        lh = get(hact,'userdata');  lk = lh{1};  if strcmp(get(lk,'tag'),'NoEdit') return; end;
        xy = getxy(lk);
        if sum(get(gcf,'SelectionT'))==321 setxy(lk,xy([1:i i i+1:end])); end;
%
        a = {CurID ix hact m get(hact,'markersize') xy a{7} a{8} i dx dy};
        setappdata(gcf,'Dedit',a);
        if ix<4 fc = get(hact,'color'); else fc = 'auto'; end;
        mk = 'd>^d>^';  msz = getappdata(gcf,'EditCur');
        set(hact,'marker',mk(ix),'markerface',fc,'markersize',msz,'buttond',b);
        es = getappdata(gcf,'EditStart');
        if length(es) if ischar(es)     feval(es,a);
                      elseif iscell(es) es = [es {a}]; feval(es{:});
                      else              es = {es a};   feval(es{:});
                      end;
        end;
      end;
    end;
    plt('grid',AX);
  else
       AX = get(y2(1),'par');  CurID = get(AX,'userdata');
       yal = get(AX,'YAxisLoc');
       if yal(1)=='r' AX2 = AX;  AX = findobj(gcf,'YAxisLoc','left','userdata',get(AX,'userdata'));
       else           AX2 = findobj(gcf,'YAxisLoc','right','userdata',CurID);
       end;
       if isempty(AX2) AX2 = -1; end;
       y8 = y2;  j = y8(2);
       clkType = sum(get(gcf,'SelectionT'));
       p = {'color'; 'marker'; 'linest'; 'linewidth'}; q = {[0 .3 .3] 'none' '-' 9};
       if clkType==649 | Narg>2
          k = y8(1);  s = isVIS(k);
          if s set(k,'vis','of'); else set(k,'vis','on'); end;
          if ishandle(j) & length(get(j,'par'))
            mk = getappdata(j,'mk');
            if s   set(j,'fonta','ita','fontw','nor'); set(mk,p,q);
            else   set(j,'fonta','nor','fontw','bol'); set(mk,p,get(k,p));
            end;
          end;
       else
          for k = findobj(get(j,'par'),'type','text')'
            t = get(k,'buttond');
            if iscell(t) & length(t{end})==2
              t = t{end}(1);
              mk = getappdata(k,'mk');
              if clkType==434 | k==j  set(t(1),'vis','on');  set(k,'fonta','nor','fontw','bol');  set(mk,p,get(t,p));
              else                      set(t(1),'vis','of');  set(k,'fonta','ita','fontw','nor');  set(mk,p,q);
              end;
            end;
          end;
       end;
       DualCur = getappdata(AX,'DualCur');
       Lh = getappdata(AX,'Lhandles');
       ls = findobj(Lh,'par',AX);
       v = 'off';
       for k=1:length(ls)
         if strcmp(get(ls(k),'vis'),'on') v = 'on';  break; end;
       end;
       set(get(AX,'ylab'),'vis',v);
       if ishandle(AX2)
         ls = findobj(Lh,'par',AX2);
         v = 'off';  leftC = get(AX2,'color');  gridXOR = leftC;
         for k=1:length(ls)
           if strcmp(get(ls(k),'vis'),'on')
             v = 'on';  leftC = 'none';  gridXOR = get(gcf,'color');
             set(AX2,'xlim',get(AX,'xlim'));
             break;
           end;
         end;
         set(AX2,'vis',v);  set(AX,'color',leftC);
         gridH = findobj(AX,'user','grid');
         if length(gridH)==1
           er = get(gridH,ERAS);
           if er(1)=='x'
             set(gridH,'color',bitxor(round(255*getappdata(gridH,'clr')),round(255*gridXOR))/255);
           end;
         end;
       end;
       TIDback = [];
       if Narg<3 & ishandle(j) TIDback = getappdata(get(j,'par'),'TIDcback'); end;
       if length(TIDback)
          setappdata(gcf,'OBJ',y2(1));  setappdata(gcf,'OBJ2',y2(2));
          evalRep(TIDback,{'@LINE' 'plt("misc",3)' '@TID' 'plt("misc",4)' '@IDX' 'plt("misc",5)'});
       end;
       axes(AX);
  end;
%

case 740,
  cid = get(gca,'userdata');  if isempty(cid) cid = getappdata(gcf,'cidP'); end;
  if isempty(cid) return; end;
  h = cur(cid,'obj');
  axes(h(13));
  if isVIS(h(1)) v = 'off';  w = 'visOFF';  else v = 'on';  w = 'visON'; end;
  k = findobj(gcf,'buttond','plt click RMS;');
  if length(k)==1 & ~isVIS(k)
        c = getappdata(gcf,'cid');
        for k = c  cur(k,w); end;
  else  cur(cid,w);
  end;
  for k = findobj(gcf,'tag','MenuBox')'
    if getappdata(k,'cid')==cid  set([k; get(k,'child')],'vis',v); end;
  end;

  z = findobj(gcf,'str','Z :    ','par',gca);
  if length(z)  zeo = getappdata(gca,'zeo');  set([z zeo(1)],'vis',v);  end;
%

case 731
  h = findobj(gcf,'user','TraceID');  if isempty(h) return; end;
  if isVIS(h(1)) v = 'off'; else v = 'on'; end;
  for k = 1:length(h) set([h(k); get(h(k),'child')],'vis',v);  end;

case 449,
  h = getappdata(gcf,'Lhandles');  n = length(h);
  q = strcmp(get(h,'vis'),'on');
  if Narg<2 Ret1 = find(q'); return; end;
  v = zeros(n,1);  w=v;  e = varargin{2};
  if ischar(e) & length(e) v=v+1;  else v(e)=1; end;
  t = findobj(gcf,'user','TraceID');
  if length(t)
        v = find(xor(v,q));
        t = [flipud(findobj(t,'type','text')); w];
        for k=1:length(v) plt('click',[h(v(k)) t(v(k))],0); end;
  else  for k=1:length(v) if v(k) set(h(k),'vis','on'); else set(h(k),'vis','of'); end; end;
  end;
%

case 439,
  mv = getappdata(gcf,'mv');
  if Narg==1  if mv plt move off; else plt move on; end; return; end;

  ui = getappdata(gcf,'uic');                          Nui = length(ui);
  si = getappdata(gcf,'sli');                          Nsi = length(si);
  ax = getappdata(gcf,'axi');                          Nax = length(ax);
  tx = getappdata(gcf,'txt');  tx = tx(ishandle(tx));  Ntx = length(tx);
  pp = getappdata(gcf,'pop');                          Npp = length(pp);

  v = varargin{2};
  if ~ischar(v)
    for k=1:length(v)
      t = v(k);
      switch get(t,'type')
        case 'uicontrol', ui = [ui t]; setappdata(gcf,'uic',ui);
        case 'text',      tx = [tx t]; setappdata(gcf,'txt',tx);
        case 'axes',      ax = [ax t]; setappdata(gcf,'axi',ax);
      end;
    end;
    return;
  end;

  if isempty(mv) & v ~= 436  setappdata(gcf,'mv',v);  plt move init;  return;  end;
  uip = {'buttond' 'ena'};
  switch sum(v)
  case 330
    f = gcf;
    if isempty(getappdata(f,'mv')) plt move init; end;
    r = getappdata(f,'snap');
    figure('menu','none','numberT','off','back','off','resize','off','pos',auxLoc(270,60),'color',[0,.4,.4],'name','SnapTo resolution','userdata',gcf,'tag',get(gcf,'tag'));
    plt('slider',[.035 .64],[r(1) 0 200 0 10000],'No. of X grid points',...
      'g = get(gcf,"user"); r = getappdata(g,"snap"); setappdata(g,"snap",[@VAL r(2)])',2);
    plt('slider',[.525 .64],[r(2) 0 200 0 10000],'No. of Y grid points',...
      'g = get(gcf,"user"); r = getappdata(g,"snap"); setappdata(g,"snap",[r(1) @VAL])',2);
    figure(f);
    return;
  case 436
    if isempty(getappdata(gcf,'snap')) setappdata(gcf,'snap',[0 0]); end;

    t = findobj(gcf,'type','text');
    for k=1:length(t);
      if isempty(getappdata(t(k),'ty')) tx = [tx t(k)]; setappdata(t(k),'ty','txt'); end;
    end;
    setappdata(gcf,'txt',tx)

    for k=1:Nsi setappdata(si(k),'ty','sli'); end;
    t = findobj(gcf,'type','uicontrol');
    for k=1:length(t)
      if isempty(getappdata(t(k),'ty')) & ~strcmp(get(t(k),'tag'),'E') ui = [ui t(k)]; setappdata(t(k),'ty','uic'); end;
    end;
    t = findobj(gcf,'type','uipanel');  r = findobj(gcf,'type','uitable');
    ui = [ui t' r'];
    for k=1:length(t) setappdata(t(k),'ty','uip'); end;
    for k=1:length(r) setappdata(r(k),'ty','uit'); end;
    setappdata(gcf,'uic',ui);
    t = findobj(gcf,'type','axes');
    for k=1:length(t)
      if isempty(getappdata(t(k),'ty')) ax = [ax t(k)]; setappdata(t(k),'ty','axi');
      end;
    end;
    setappdata(gcf,'axi',ax);
    setappdata(gcf,'mv',0);
    if length(mv) plt('move',mv); end;
  case 221
    if mv return; end;
    setappdata(gcf,'mv',1);
    tidmvs = 'plt misc tidmv;';
    for k=1:Nui uik = ui(k);  tys = sum(getappdata(uik,'ty'));
                if tys==334 uipp='buttond'; else uipp=uip; end;
                setappdata(uik,'CBsv',get(uik,uipp));
                if tys==334 | tys==306
                   set(uik,'buttond',tidmvs);
                else
                  set(uik,'ena','of','buttond',tidmvs);
                end;
    end;
    for k=1:Nsi setappdata(si(k),'CBsv',get(si(k),uip));
                set(si(k),'ena','of','buttond','plt misc slimv;');
                setappdata(si(k),'ty','sli');
    end;
    for k=1:Nax setappdata(ax(k),'CBsv',get(ax(k),'buttond'));
                set(ax(k),'buttond',tidmvs);
    end;
    for k=1:Ntx setappdata(tx(k),'CBsv',get(tx(k),'buttond'));
                set(tx(k),'buttond','plt misc txtmv;');
    end;
    for k=1:Npp setappdata(pp(k),'CBsv',get(pp(k),'buttond'));
                set(pp(k),'buttond',tidmvs);
    end;
    setappdata(gcf,'CBsv',get(gcf,'buttond'));  set(gcf,'buttond','');
    gr = findobj(gcf,'user','grid');
    if length(gr) gr=gr(end); setappdata(gr,'CBsv',get(gr,'buttond')); set(gr,'buttond',tidmvs); end;
    set(findobj(gcf,'str','D','fontn','symbol'),'str',char(222));
  case 315
    if ~mv return; end;
    setappdata(gcf,'mv',0);
    if strcmpi(get(gcbo,'type'),'text') c = get(gcbo,'color'); else c = 0; end;
    if c(1) == .99  tbox = findobj(gcf,'user','TraceID');
                    if ishandle(tbox) p = get(tbox,'pos');
                                      if p(2)<0  plt('hidecur');
                                        set(tbox,'pos',p+[0 2222 0 0]);
                                      end;
                    end;
    end;
    set(findobj(gcf,'str',char(222),'fontn','symbol'),'str','D');
    for k=1:Nui if sum(getappdata(ui(k),'ty'))==334
                     set(ui(k),'buttond',getappdata(ui(k),'CBsv'));
                else set(ui(k),uip,getappdata(ui(k),'CBsv'));
                end;
    end;
    for k=1:Nsi set(si(k),uip,     getappdata(si(k),'CBsv')); end;
    for k=1:Nax set(ax(k),'buttond',   getappdata(ax(k),'CBsv')); end;
    for k=1:Ntx set(tx(k),'buttond',   getappdata(tx(k),'CBsv')); end;
    for k=1:Npp set(pp(k),'buttond',   getappdata(pp(k),'CBsv')); end;
    set(gcf,'buttond',getappdata(gcf,'CBsv'));
    gr = findobj(gcf,'user','grid');
    if length(gr) gr=gr(end); set(gr,'buttond',getappdata(gr,'CBsv')); end;
  end;

case 534,   for f = findobj('type','fig')'
                   b = get(f,'buttond');
                   if iscell(b) & length(b)>2 & sum(lower(b{3}))==634
                     set(f,'closereq','closereq'); close(f);
                   end;
               end;
               setappdata(0,'CurMain',[]);
case 632,  a = flipud(findobj(findobj(gcf,'user','TraceID'),'type','text'));
               b = varargin{2};  if ~iscell(b) b = {b}; end;
               if nargin>2 c = varargin{3}-1; else c = 0; end;
               set(a(c+(1:length(b))),{'str'},b(:));
case 641,  set(gcf,'SelectionT','alt');    cur(varargin{2:end});
case 526,   set(gcf,'SelectionT','normal'); cur(varargin{2:end});
case 662,  set(gcf,'SelectionT','alt');    plt('click',varargin{2:end});
case 547,   set(gcf,'SelectionT','normal'); plt('click',varargin{2:end});
case 774, Ret1 = '14Sep23'; Ret2 = 0;

otherwise, [Ret1 Ret2] = pltinit(varargin{:});
%
end;
%


function t = logTicks(lim)
  a = lim(1);  b = lim(2);
  if a<=0 | b<=0  t=lim; return; end;
  ex = floor(log10(a));  p = 10^ex;
  d = floor(a/p);  t = d*p;
  while 1
    d = d+1;
    if d>9 d=1; ex=ex+1;  p=p*10; end;
    v = d*p;   t = [t v];
    if v>=b break; end;
  end;
%

function mZoom(xy)
  s = {'Lens' 'MotionZoom'};
  for k = 1:2
    a = getappdata(gca,s{k});
    if length(a)
      x = sort(xy(1:2));  y = sort(xy(3:4));
      if diff(x) & diff(y)
        b = [x y];
        if ischar(a)     feval(a,b);
        elseif iscell(a) a = [a {b}]; feval(a{:});
        else             a = {a b};   feval(a{:});
        end;
      end;
      return;
    end;
  end;
%

function fixMark()
  markR = findobj(gcf,'tag','markR')';
  if isempty(markR) return; end;
  for l = markR
    u = get(l,'userdata');
    t = u{1};  ax = u{2};  axr = u{3};  ylim = u{4};  rlim = u{5};
    if ishandle(t) p = get(t,'pos');  else p = [0 0]; end;
    y = [get(l,'y') p(2)];
    y = rlim(1) + diff(rlim) * (y - ylim(1)) / diff(ylim);
    rlim = get(axr,'ylim');   ylim = get(ax,'ylim');
    y = ylim(1) + diff(ylim) * (y - rlim(1)) / diff(rlim);
    set(l,'y',y(1),'userdata',[u(1:3) {ylim rlim}]);
    if ishandle(t) p(2) = y(2);  set(t,'pos',p); end;
  end;
%

function edg(txt,clr)
  v6 = version;  v6 = (v6(1)=='6');
  if nargin>1
    if v6 if strcmp(clr,'none') return; end;
          a = get(txt,'par');
          xl = get(a,'xlim'); yl = get(a,'ylim');
          setappdata(txt,'li',line(0,0,'par',a,'color',clr,'clip','off'));
          set(a,'xlim',xl,'ylim',yl);
    else  set(txt,'edge',clr);
    end;
  elseif v6  li = getappdata(txt,'li');
             if ishandle(li)
               e = get(txt,'extent');  x=e(1); y=e(2); x2=x+e(3); y2=y+e(4)*1.1;
               set(li,'x',[x x2 x2 x x],'y',[y y y2 y2 y]);
             end;
  end;
%

function v = auxLoc(w,h,au)
     f = findobj('type','fig','tag',get(gcf,'tag'));  nfig = length(f);
     if nargin==3
       area = 0;
       for k=1:nfig
         p = get(f(k),'pos'); p = prod(p(3:4)); if p>area area=p; gf=f(k); end;
       end;
     else gf=gcf; au=0;
     end;
     set(0,'unit','pix');  sz = get(0,'screens');
     szw = sz(3) - w - 4;
     ppos  = get(gf,'pos');
     if ppos(4)<1 sp = sz(3:4); ppos = ppos .* [sp sp]; end;
     x = min(ppos(1)+ppos(3)+9,szw) + au;
     y = ppos(2) + ppos(4) - h - 30*(nfig-1);
     v = [x y w h];
%

function AXeval(a)
  cb1 = get(a,'userdata');          if length(cb1) evalQ(cb1); end;
  cb2 = getappdata(a,'CB2');  if length(cb2) evalQ(cb2); end;

function evalQ(a)
  if ischar(a)     a = strrep(a,'"','''');
                   eval(a);
  elseif iscell(a) feval(a{:});
  else             feval(a);
  end;
%

function evalRep(a,rep)
  if ischar(a)     for k=1:2:length(rep) a = strrep(a,rep{k},rep{k+1}); end;
                   a = strrep(a,'"','''');
                   eval(a);
  elseif iscell(a) feval(a{:});
  else             feval(a);
  end;
%

function [rpt,p] = getREPEAT(e)
  rpt = getappdata(gcbo,'repeat');
  if nargin & isempty(rpt)
     b = get(gcbo,'buttond');
     if iscell(b) & length(b)>2 rpt = getappdata(b{3},'repeat'); end;
  end;
  if length(rpt)>1 p = rpt(2);
  else       p = .5;  if exist('p') p = .4; end;
  end;  
  if length(rpt) rpt = rpt(1);
  else           rpt = .03;
  end;
%

function s = ctriple(val)
  s = strrep(prin(' {%3w!  }',val),' 0.','.');
  if s(1)==' ' s = s(2:end); end;
%

function c = ctrip(v)
  if ischar(v) c = v;  return; end;
  [s1 s2] = size(v);
  if s1>1 c = [];
          for k = 1:s1  c = [c; ctrip(v(k,:))]; end;
          return;
  end;
  if s2==3
       if max(v)>1 c = v/100; else c = v; end;
  else v1 = floor(v/10000);  v = v - 10000*v1;
       v2 = floor(v/100);    v = round(v - 100*v2);
       c = [v1 v2 v];
       c(find(c==1))=100;
       c = c/100;
  end;
%

function v = isVIS(h)
   v = strcmp(get(h,'vis'),'on');
%

function b = isequalNaN(x,y)
  x(isnan(x)) = 123456789;
  y(isnan(y)) = 123456789;
  b = isequal(x,y);
%

function r = getap(v)
  r = getappdata(gcf,v);
  if isempty(r) g = findobj('type','figure','tag',get(gcf,'tag'));
                for k=1:length(g) r = getappdata(g(k),v);
                                  if length(r) break; end;
                end;
  end;
%

function c = getxy(h)
  c = complex(get(h,'x'),get(h,'y'));
%

function setxy(h,c)
  set(h,'x',real(c),'y',imag(c));
%

function v = s2d(s)
   v = sscanf(s,'%f');
%

function v = s2i(s)
   v = sscanf(s,'%d');
%
